import { Directive, Optional, ViewContainerRef, Input, TemplateRef } from "@angular/core";
import { Globals } from './global';
import { FormRole } from './role-resolver.service';

@Directive({
    selector: '[pms-role]'
})

export class RoleDirective {
    private role: FormRole;
    @Input("pms-role") pmsRole: string | Array<string>;

    constructor(
        private templateRef: TemplateRef<any>,
        private viewRef: ViewContainerRef,
        @Optional() private global: Globals
    ) {
        this.role = this.global.GetRoleDetail();
    }

    ngOnInit(): void {
        if (typeof this.pmsRole === "string") {
            if (this.role[this.pmsRole] !== 'Y')
                this.viewRef.clear();
            else {
                this.viewRef.createEmbeddedView(this.templateRef)
            }
        } else {
            let finalResult = this.pmsRole.reduce((a, b) => {
                return a || this.role[b] === 'Y';
            }, false) ?
                this.viewRef.createEmbeddedView(this.templateRef) :
                this.viewRef.clear()
        }
    }
}