import { NgModule, Component } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';

import { SharedComponentModule } from '../shared/shared-component.module';
import { SaleOrderModule } from '../saleorder/saleorder.module';

import { AuthGuard } from 'src/app/core/auth-guard.service';

import { AccountingComponent } from '../../pages/accounting/accounting.component';
// import { SNSQ093Component } from '../../pages/accounting/SNSQ093/SNSQ093.component';
import { MaterialImportModule } from '../shared/material.module';
import { RoleResolver } from 'src/app/core/role-resolver.service';
import { SNPR027Component } from 'src/app/pages/accounting/SNPR027/SNPR027.compoent';
import { SNM060PComponent } from 'src/app/pages/accounting/SNM060P/SNM060P.component';
import { SNM019PComponent } from 'src/app/pages/accounting/SNM019P/SNM019P.component';
import { SNSD201Component } from 'src/app/pages/accounting/SNSD201/SNSD201.component';
import { SNSE069_MComponent } from 'src/app/pages/accounting/SNSE069_M/SNSE069_M.component';
import { SNM004PComponent } from 'src/app/pages/master/SNM004P/SNM004P.component';
import { SNM005PComponent } from 'src/app/pages/master/SNM005P/SNM005P.component';
import { SNIE002Component } from 'src/app/pages/accounting/SNIE002/SNIE002.component';
import { SNSJ007_MComponent } from 'src/app/pages/accounting/SNSJ007_M/SNSJ007_M.component';
import { SNSJ006_MComponent } from 'src/app/pages/accounting/SNSJ006_M/SNSJ006_M.component';
import { SNSJ006_M2Component } from 'src/app/pages/accounting/SNSJ006_M2/SNSJ006_M2.component';
import { SNPE042Component } from 'src/app/pages/accounting/SNPE042/SNPE042.component';
import { SNPE043Component } from 'src/app/pages/accounting/SNPE043/SNPE043.component';
import { SNSR015Component } from 'src/app/pages/accounting/SNSR015/SNSR015.component';
import { SNSR015_A4Component } from 'src/app/pages/accounting/SNSR015_A4/SNSR015_A4.component';
import { SNM032PComponent } from '../../pages/accounting/SNM032P/SNM032P.component';
import { SNM029PComponent } from '../../pages/accounting/SNM029P/SNM029P.component';
import { SNIE001MComponent } from 'src/app/pages/accounting/SNIE001_M/SNIE001_M.component';
import { SNPE020_OUMComponent } from 'src/app/pages/accounting/SNPE020_OUM/SNPE020_OUM.component';
import { SNPE021Component } from 'src/app/pages/accounting/SNPE021/SNPE021.component';
import { SNPE024_MComponent } from 'src/app/pages/accounting/SNPE024_M/SNPE024_M.component';
import { SNPE019_MComponent } from 'src/app/pages/accounting/SNPE019_M/SNPE019_M.component';
import { SNM027PComponent } from 'src/app/pages/accounting/SNM027P/SNM027P.component';
import { SNPP104_MComponent } from 'src/app/pages/accounting/SNPP104_M/SNPP104_M.component';
import { SNM036PComponent } from 'src/app/pages/accounting/SNM036P/SNM036P.component';
import { SNPE031_MComponent } from 'src/app/pages/accounting/SNPE031_M/SNPE031_M.component';
import { SNPE032Component } from 'src/app/pages/accounting/SNPE032/SNPE032.component';
import { SNPR026_MComponent } from 'src/app/pages/inventory/SNPR026_M/SNPR026_M.component';
import { SNPR026_PA4Component } from 'src/app/pages/inventory/SNPR026_PA4/SNPR026_PA4.component';
import { SNPR025Component } from 'src/app/pages/accounting/SNPR025/SNPR025.component';
import { SNPE018_MComponent } from 'src/app/pages/accounting/SNPE018_M/SNPE018_M.component';
import { SNPE040_MComponent } from 'src/app/pages/accounting/SNPE040_M/SNPE040_M.component';
import { SNPE037_MComponent } from 'src/app/pages/accounting/SNPE037_M/SNPE037_M.component';
import { SNPE035_MComponent } from 'src/app/pages/accounting/SNPE035_M/SNPE035_M.component';
import { SNPE041Component } from 'src/app/pages/accounting/SNPE041/SNPE041.component';
import { SNSE041_MComponent } from 'src/app/pages/accounting/SNSE041_M/SNSE041_M.component';
import { SNSE041_M2Component } from 'src/app/pages/accounting/SNSE041_M2/SNSE041_M2.component';
import { SNPE045Component } from 'src/app/pages/accounting/SNPE045/SNPE045.component';

import { SNPP104_NPComponent } from 'src/app/pages/accounting/SNPP104_NP/SNPP104_NP.component';
import { SNPP104_NPSearchComponent } from 'src/app/pages/accounting/SNPP104_NP/Search/SNPP104_NP-search.component';
import { SNPP104_NPUploadComponent } from 'src/app/pages/accounting/SNPP104_NP/Upload/SNPP104_NP-upload.component';
import { SNPP104_NPDetailComponent } from 'src/app/pages/accounting/SNPP104_NP/Detail/SNPP104_NP-detail.component';
import { AccountReportComponent } from 'src/app/pages/accounting/AccountReport/AccountReport.component';
@NgModule({
  declarations: [
    AccountingComponent,
    // SNSQ093Component,
    SNPR025Component,
    SNPR026_MComponent,
    SNPR026_PA4Component,
    SNM036PComponent,
    SNPP104_MComponent,
    SNPE019_MComponent,
    SNPR027Component,
    SNM060PComponent,
    SNM019PComponent,
    SNSD201Component,
    SNSE069_MComponent,
    SNM004PComponent,

    SNIE002Component,
    SNSJ007_MComponent,
    SNSJ006_MComponent,
    SNSJ006_M2Component,
    SNM005PComponent,
    SNPE042Component,
    SNPE043Component,
    SNSR015Component,
    SNSR015_A4Component,
    SNM027PComponent,
    SNM032PComponent,
    SNM029PComponent,
    SNIE001MComponent,
    SNPE020_OUMComponent,
    SNPE021Component,
    SNPE024_MComponent,
    SNPE031_MComponent,
    SNPE032Component,
    SNPE018_MComponent,
    SNPE040_MComponent,
    SNPE037_MComponent,
    SNPE035_MComponent,
    SNPE041Component,
    SNSE041_MComponent,
    SNSE041_M2Component,
    SNPE045Component,
    
    SNPP104_NPComponent,
    SNPP104_NPSearchComponent,
    SNPP104_NPUploadComponent,
    SNPP104_NPDetailComponent,
    AccountReportComponent
  ],

  imports: [
    SaleOrderModule,
    CommonModule,
    HttpClientModule,
    FormsModule,
    ReactiveFormsModule,
    SharedComponentModule,
    FormsModule,

    //Material imports
    MaterialImportModule,

    RouterModule.forChild([
      {
        path: '',
        component: AccountingComponent,
        children: [
          {
            path: 'SNPE045',
            component: SNPE045Component,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNSE041_M',
            component: SNSE041_MComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNSE041_M2',
            component: SNSE041_M2Component,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNPR025',
            component: SNPR025Component,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNPR026_M',
            component: SNPR026_MComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNPR026_PA4',
            component: SNPR026_PA4Component,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNM036P',
            component: SNM036PComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNPP104_M',
            component: SNPP104_MComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNM027P',
            component: SNM027PComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNPE019_M',
            component: SNPE019_MComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNPE018_M',
            component: SNPE018_MComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSJ006_M',
            component: SNSJ006_MComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNSJ006_M2',
            component: SNSJ006_M2Component,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNSJ007_M',
            component: SNSJ007_MComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNIE002',
            component: SNIE002Component,
            resolve: {
              role: RoleResolver
            }
          },

          {
            path: 'SNPR027',
            component: SNPR027Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNM005P',
            component: SNM005PComponent,
            resolve: {
              role: RoleResolver
            }

          },
          {
            path: 'SNM060P',
            component: SNM060PComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNM019P',
            component: SNM019PComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSD201',
            component: SNSD201Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE069_M',
            component: SNSE069_MComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNM004P',
            component: SNM004PComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNPE040_M',
            component: SNPE040_MComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNPE037_M',
            component: SNPE037_MComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNPE035_M',
            component: SNPE035_MComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNPE042',
            component: SNPE042Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNPE043',
            component: SNPE043Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSR015',
            component: SNSR015Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSR015_A4',
            component: SNSR015_A4Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNPE041',
            component: SNPE041Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNM032P',
            component: SNM032PComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNM029P',
            component: SNM029PComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNIE001_M',
            component: SNIE001MComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNPE020_OUM',
            component: SNPE020_OUMComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNPE021',
            component: SNPE021Component,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNPE024_M',
            component: SNPE024_MComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNPE031_M',
            component: SNPE031_MComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNPE032',
            component: SNPE032Component,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNPP104_NP',
            component: SNPP104_NPComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'ACCREP',
            component: AccountReportComponent,
            resolve: {
              role: RoleResolver
            }
          }
        ],
        canActivate: [AuthGuard]
      }
    ])
  ],
  exports: [],
  providers: [
    AuthGuard,
    RoleResolver
  ],
})
export class AccountingModule { }

