import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';

import { SharedComponentModule } from '../shared/shared-component.module';
import { AuthGuard } from 'src/app/core/auth-guard.service';

import { MasterComponent } from 'src/app/pages/master/master.component';

import { SNM001P_MComponent } from 'src/app/pages/master/SNM001P_M/SNM001P_M.component';
// import { SNM001P_M_MCComponent } from 'src/app/pages/master/SNM001P_M_MC/SNM001P_M_MC.component';
// import { SNM004PComponent } from 'src/app/pages/master/SNM004P/SNM004P.component';
// import { SNM005PComponent } from 'src/app/pages/master/SNM005P/SNM005P.component';
import { SNM020PComponent } from 'src/app/pages/master/SNM020P/SNM020P.component';
import { SNM023PComponent } from 'src/app/pages/master/SNM023P/SNM023P.component';
import { SNM042PComponent } from 'src/app/pages/master/SNM042P/SNM042P.component';
import { SNM049PComponent } from 'src/app/pages/master/SNM049P/SNM049P.component';
import { SNM081PComponent } from 'src/app/pages/master/SNM081P/SNM081P.component';
import { SNM056SComponent } from 'src/app/pages/master/SNM056S/SNM056S.component';
import { SNM056PComponent } from 'src/app/pages/master/SNM056P/SNM056P.component';
//import { SNM033Component } from 'src/app/pages/master/SNM033/SNM033.component';
import { SNM033PComponent } from 'src/app/pages/master/SNM033P/SNM033P.component';
import { MaterialImportModule } from '../shared/material.module';
import { RoleResolver } from 'src/app/core/role-resolver.service';
import { SNM011PComponent } from 'src/app/pages/master/SNM011P/SNM011P.component';

import { SNM083Component } from 'src/app/pages/master/SNM083/SNM083.component';



@NgModule({
  declarations: [
    MasterComponent,
    SNM001P_MComponent,
    // SNM001P_M_MCComponent,
    // SNM004PComponent,
    // SNM005PComponent,
    SNM020PComponent,
    SNM023PComponent,
    SNM042PComponent,
    SNM049PComponent,
    SNM081PComponent,
    SNM056SComponent,
    SNM056PComponent,
    //SNM033Component,
    SNM033PComponent,
    SNM011PComponent,
        SNM083Component,
  ],
  imports: [
    CommonModule,
    HttpClientModule,
    FormsModule,
    ReactiveFormsModule,
    SharedComponentModule,
    FormsModule,

    //Material imports
    MaterialImportModule,

    RouterModule.forChild([
      {
        path: '',
        component: MasterComponent,
        children: [
          // {
          //   path: 'SNM001P_M_MC',
          //   component: SNM001P_M_MCComponent,
          //   resolve: {
          //     role: RoleResolver
          //   },
          // },
          {
            path: 'SNM001P_M',
            component: SNM001P_MComponent,
            resolve: {
              role: RoleResolver
            },
          },
          // {
          //   path: 'SNM004P',
          //   component: SNM004PComponent,
          //   resolve: {
          //     role: RoleResolver
          //   },
          // },
          // {
          //   path: 'SNM005P',
          //   component: SNM005PComponent,
          //   resolve: {
          //     role: RoleResolver
          //   },
          // },
           {
             path: 'SNM020P',
             component: SNM020PComponent,
             resolve: {
               role: RoleResolver
             },
           },
          {
            path: 'SNM023P',
            component: SNM023PComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNM042P',
            component: SNM042PComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNM083',
            component: SNM083Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNM049P',
            component: SNM049PComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNM081P',
            component: SNM081PComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNM056S',
            component: SNM056SComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNM056P',
            component: SNM056PComponent,
            resolve: {
              role: RoleResolver
            },
          },
          // {
          //   path: 'SNM033',
          //   component: SNM033Component,
          //   resolve: {
          //     role: RoleResolver
          //   },
          // },
          {
            path: 'SNM033P',
            component: SNM033PComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNM011P',
            component: SNM011PComponent,
            resolve: {
              role: RoleResolver
            }
          }
        ],
        canActivate: [AuthGuard]
      }
    ])
  ],
  exports: [],
  providers: [AuthGuard, RoleResolver],
})
export class MasterModule { }
