import { Component, OnInit, ViewContainerRef } from "@angular/core";
import * as moment from "moment";
import { Globals } from "src/app/core/global";
import { HttpService } from "src/app/core/http.service";
import { ModalService } from "src/app/core/modal.service";

@Component({
  selector: "account-report",
  templateUrl: "AccountReport.component.html",
  styleUrls: ["AccountReport.component.css"],
})
export class AccountReportComponent implements OnInit {
  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private global: Globals
  ) {}

  public currentDate: moment.Moment;
  public countRow: number;

  ngOnInit() {
    this.currentDate = moment();
    // this.GetCurrentDate();
  }

  GetCurrentDate() {
    this.http.GetSystemDate().subscribe((d) => {
      this.currentDate = moment(d);
    });
  }

  RunReport(reportName: string) {
    this.global.GoToReport(reportName, {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
    }, true, true);
  }
}
