import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { FormGroup, FormControl, FormBuilder } from '@angular/forms'
import { Router, ActivatedRoute } from '@angular/router';
import { Observable, config } from 'rxjs';
import { MatTableDataSource } from '@angular/material/table';
import { MatPaginator } from '@angular/material/paginator';
import { MatSort } from '@angular/material/sort';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { Globals } from '../../../core/global';
import { ModalService } from '../../../core/modal.service';
import { AutoCompleteQueryComponent } from 'src/app/components/shared/auto-complete-query/auto-complete-query.component';
import * as moment from 'moment';

@Component({
  selector: 'SNPE024_M',
  templateUrl: './SNPE024_M.component.html',
  styleUrls: ['./SNPE024_M.component.css']
})

export class SNPE024_MComponent implements OnInit {

  constructor(
    private http: HttpService,
    private auth: AuthDecode,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private router: Router,
    private global: Globals,
    private route: ActivatedRoute,
  ) { }
  @ViewChild("dialogDoc", { static: false }) dialogDoc: any;
  @ViewChild("dialogDate", { static: false }) dialogDate: any;
  @ViewChild("dialogVat", { static: false }) dialogVat: any;
  @ViewChild("dialogInvo", { static: false }) dialogInvo: any;
  @ViewChild("dialogCom", { static: false }) dialogCom: any;
  @ViewChild("dialogPart", { static: false }) dialogPart: any;
  @ViewChild("autocompleteVat", { static: false }) autocompleteVat: AutoCompleteQueryComponent;

  public sDocData: any;
  public sDateData: any;
  public sData: any;
  public sVatData: any;
  public sInvoData: any;
  public sComData: any;
  public DisableSave: any = true;
  public DisableCancel: any = true;
  public ShowDetail = false;
  public PageNo = "";;
  public tableWorkFile: any = [];
  public valid: boolean = false;
  public oldValue: any;
  public ConfirmStatus: any = "";
  public businessplace: any;

  public ParamsSearch = {
    DOCUMENT_NO: '',
    DOCUMENT_DATE: null,
    DOCUMENT_DATE_SEARCH: moment(),
    DEST_PORT: null,
    VAT_NAME: null,
    VAT_LOOKUP: null,
    INVOICE_NO: null,
    INVOICE_DATE: null,
    INVOICE_DATE_SEARCH: null,
    DOCUMENT_TYPE: null,
    P_FORM_NO: null,
    VENDOR_CODE: null,
    CONFIRM_STATUS: null
  }
  public BusnessPlaces: any = [
    '00000','00001', '00002', '00003', '00004', '00005', '00006', '00007', '00008', '00009', '00010',
    '00011', '00012', '00013', '00014', '00015', '00016', '00017', '00018', '00019', '00020'
  ];

  public ParamsHeadData = {
    DOCUMENT_TYPE: null,
    DOCUMENT_TIME: null,
    DOCUMENT_NO: null,
    DOCUMENT_DATE: null,
    JOB_TYPE: null,
    REF_DOC_TYPE: null,
    REF_DOC_NO: null,
    REF_DOC_DATE: null,
    REF_INV_NO: null,
    REF_INV_DATE: null,
    TOTAL_AVG_AMT: null,
    TOTAL_STD_AMT: null,
    TOTAL_RETAIL_B: null,
    TOTAL_RETAIL_C: null,
    TOTAL_NET_B: null,
    TOTAL_DISCOUNT: null,
    TOTAL_VAT: null,
    VENDOR_CODE: null,
    VENDOR_TYPE: null,
    CONFIRM_DATE: null,
    DEST_PORT: null,
    VAT_FLAG: null,
    VAT_RATE: null,
    ATTRIBUTE5: null,
    TOTAL_CASE: null,
    TOTAL_ITEM: null,
    TOTAL_QTY: null,
    REASON_CODE: null,
    LAST_UPD_BY: null,
    LAST_UPD_DATE: null,
    TOTAL_OLD_AMT: null,
    BUSINESS_PLACE: null,
    VAT_DESC: null,
    TAX_FLAG: null,
    TAX_RATE: null,
    VENDOR_NAME: null,
    TOTAL_AMOUNT: null,
    TNAME: null,
    TMP_TOT_LOC: null,
    TMP_TOT_IMP: null,
    INDENT_STATUS: null,
    DSP_DOC_NO: null,
    REF_INV_DATE_FORMAT: null,
    DOCUMENT_DATE_FORMAT: null,
    TMP_INV_NO: null,
    TMP_INV_DATE: null
  }

  public data : any = {}

  public tblFooterDetail35: any = [
    {
      fieldName: "PART_NAME",
      value: "Total",
      show: true
    },
    {
      fieldName: "QUANTITY",
      // value: false,
      show: true
    },
    {
      fieldName: "AMOUNT",
      // value: false,
      show: true
    }]

  public ParamsDetailData = {
    DOCUMENT_TYPE: null,
    DOCUMENT_NO: null,
    ITEM_NO: null,
    CONFIRM_DATE: null,
    VENDOR_CODE: null,
    VENDOR_TYPE: null,
    RETAIL_PRICE_B: null,
    UNIT_PRICE_B: null,
    UNIT_PRICE_C: null,
    NET_AMT_B: null,
    ORDER_NO: null,
    ORDER_DATE: null,
    ORDER_ITEM_NO: null,
    SUB_ITEM_NO: null,
    ORDER_PART_NO: null,
    ACCEPT_PART_NO: null,
    REASON_CODE: null,
    ITEM_QTY: null,
    KIT_FLAG: null,
    SUB_DOC_NO: null,
    JOB_TYPE: null,
    SEQ: null
  }

  public ParamsWorkfile = {
    TMP_DOC_NO: null,
    TMP_DOC_DATE: null,
    REASON_CODE: '501',
    REASON_NAME_EN: 'ประกอบเป็นชุดใหญ่'
  }

  public tblFooterDetail: any = [
    {
      fieldName: "KIT_FLAG",
      value: "Total",
      show: true
    },
    {
      fieldName: "ITEM_QTY",
      value: null,
      show: true
    },
    {
      fieldName: "TMP_AMOUNT",
      value: null,
      show: true
    }]

  public tblFooterWorkFile: any = [
    {
      fieldName: "PART_NAME",
      value: "Total",
      show: true
    },
    {
      fieldName: "QUANTITY",
      value: null,
      show: true
    },
    {
      fieldName: "AMOUNT",
      value: null,
      show: true
    }]



  public tableData: any;
  public tableName: string;
  public PartListData: any;
  public ConfigDoc: any = {
    ColName: "DOCUMENT_NO",
    ColValue: "",
    PlaceholderText: "Select Document",
    SourceController: "AC",
    SourceMethodName: "SNPE024_M_GetDoc",
    NoOfShowRecords: 30,
    MinLengthSearch: 5,
    UpperCase: false
  }

  public ConfigVat: any = {
    ColName: "LOOKUP_VAT",
    ColValue: "",
    PlaceholderText: "Select Vat",
    SourceController: "AC",
    SourceMethodName: "SNPE024_M_GetVat",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public ConfigVat2: any = {
    ColName: "LOOKUP_VAT",
    ColValue: "",
    PlaceholderText: "Select Vat",
    SourceController: "AC",
    SourceMethodName: "SNPECOMMON_GetVat",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false,
    SourceParams: {
      INV_DATE : this.data.REF_INV_DATE
    },
  }

  public ConfigInv: any = {
    ColName: "LOOKUP_INV",
    ColValue: "",
    PlaceholderText: "Select Rate",
    SourceController: "AC",
    SourceMethodName: "SNPE024_M_GetInv",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: false
  }

  public ConfigInvSearch: any = {
    ColName: "INVOICE_NO",
    ColValue: "",
    PlaceholderText: "Select Rate",
    SourceController: "AC",
    SourceMethodName: "SNPE024_M_GetInv",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: false
  }

  public ConfigCom: any = {
    ColName: "SK_SYSTEM_ID",
    ColValue: "SK_SYSTEM_ID",
    PlaceholderText: "Select Company",
    SourceController: "AC",
    SourceMethodName: "SNPE024_M_GetCom",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: false
  }

  public ConfigDocDate: any = {
    ColName: "DOCUMENT_DATE",
    ColValue: "",
    PlaceholderText: "Select Document Date",
    SourceController: "AC",
    SourceMethodName: "SNPE024_M_GetDate",
    NoOfShowRecords: 50,
    MinLengthSearch: 2
  }

  public ConfigInvoiceDate: any = {
    ColName: "REF_INV_DATE",
    ColValue: "",
    PlaceholderText: "Select Invoice Date",
    SourceController: "AC",
    SourceMethodName: "SNPE018_M_GetInvoiceDate",
    NoOfShowRecords: 50,
    MinLengthSearch: 2
  }

  public ConfigPart: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Part No.",
    SourceController: "AC",
    SourceMethodName: "SNPE018_M_GetPart",
    NoOfShowRecords: 30,
    MinLengthSearch: 3,
    UpperCase: true
  }

  public ConfigVendor: any = {
    ColName: "LOOKUP_VENDOR_NAME",
    ColValue: "",
    PlaceholderText: "Select Vender Code",
    SourceController: "AC",
    SourceMethodName: "SNPE024_M_GetVendor",
    NoOfShowRecords: 50,
    MinLengthSearch: 0
  }


  ngOnInit() {
    this.PageNo = "SNPE024_M";
    this.ParamsSearch.DOCUMENT_TYPE = "RC";
    this.ParamsSearch.P_FORM_NO = "SNPE024_M";
    
   
  }

  ChenkBusinessplace(event){
     
    if(event.length <= 5){
      let getlenght = 5 - event.length
      switch(getlenght) 
      {
        case 0 :
          this.data.BUSINESS_PLACE = event
          break;
        case 1 :
          this.data.BUSINESS_PLACE = "0" + event
          break;
        case 2 :
          this.data.BUSINESS_PLACE = "00" + event
          break;
        case 3 :
          this.data.BUSINESS_PLACE = "000" + event
          break;
        case 4 :
          this.data.BUSINESS_PLACE = "0000" + event
          break;
        case 5 :
          this.data.BUSINESS_PLACE =  "00000"
          break;
        default:
          this.data.BUSINESS_PLACE = "00000"
          break;
      }
    }else{
      this.data.BUSINESS_PLACE = "00000"
    }
  }

  FormatDate(date) {

    let d = new Date(date);
    let Day = d.getDate().toString();
    let NewDay = Day.toString().length < 2 ? '0' + Day.toString() : Day.toString()
    let Month = d.getMonth() + 1;
    let NewMonth = Month.toString().length < 2 ? '0' + Month.toString() : Month.toString()
    let Year = d.getFullYear().toString();
    return Year + NewMonth + NewDay;
  }

  BackToGrid() {
    this.ShowDetail = false;
  }

  // DeliveryChange(evt) {
  //   this.businessplace = evt.BUSINESS_PLACE;
  //   this.data.BUSINESS_PLACE = evt.BUSINESS_PLACE;

  // }

  Search() {
    this.ShowDetail = false;
    this.tableData = [];
    if (this.ParamsSearch.DOCUMENT_DATE_SEARCH) {
      this.ParamsSearch.DOCUMENT_DATE = this.FormatDate(this.ParamsSearch.DOCUMENT_DATE_SEARCH)
    } else {
      this.ParamsSearch.DOCUMENT_DATE = null;
    }
    if (this.ParamsSearch.INVOICE_DATE_SEARCH) {
      this.ParamsSearch.INVOICE_DATE = this.FormatDate(this.ParamsSearch.INVOICE_DATE_SEARCH)
    } else {
      this.ParamsSearch.INVOICE_DATE = null
    }
    if (this.ConfirmStatus === "Y") {
      this.ParamsSearch.CONFIRM_STATUS = "Y";
    }
    if (this.ConfirmStatus === "N") {
      this.ParamsSearch.CONFIRM_STATUS = "N";
    }
    this.http.post("AC", "SNPE024_M_GetTransactionHeader", this.ParamsSearch)
      .subscribe(res => {
        this.tableData = res.Table;

      })
  }

  ViewClick(event) {
    console.log(event)
    if ((event.CONFIRM_DATE !== null && event.CONFIRM_DATE !== "") && event.INDENT_STATUS == 'N') {
      this.modal.warning("Can Not Confirm Because This Document Not To Shevle", this.viewref)
    }
    this.data.DOCUMENT_TYPE = event.DOCUMENT_TYPE;
    this.data.DOCUMENT_NO = event.DOCUMENT_NO;
    //this.ParamsSearch.DOCUMENT_TYPE = event.DOCUMENT_TYPE;
    //this.ParamsSearch.DOCUMENT_NO = event.DOCUMENT_NO;
    this.FindHeadAuto();
    this.ShowDetail = true;
  }

  ValidatePart(autocomplete, event, data) {
    if (this.tableWorkFile.filter(x => x.PART_NO).length > 0) {

      let foundDup = this.tableWorkFile.some(x => x.PART_NO == event.PART_NO)
      let foundQuantity = this.tableWorkFile.some(x => x.PART_NO && !x.QUANTITY)
      if (foundDup) {
        this.modal.warning("P# " + event.PART_NO + " is duplicated!", this.viewref)
        this.valid = false;
      } else if (foundQuantity) {
        this.modal.warning("Please enter the quantity", this.viewref)
        this.valid = false;
      } else {
        let index = this.tableWorkFile.findIndex(x => x.SEQ == data.SEQ)
        this.tableWorkFile[index].PART_NO = event.PART_NO
        this.tableWorkFile[index].PART_NAME = event.PART_NAME_EN
        this.tableWorkFile[index].UNIT_PRICE = event.AVERAGE_COST
        this.valid = false;
        this.tableWorkFile = this.tableWorkFile.slice();
      }
    } else {
      let index = this.tableWorkFile.findIndex(x => x.SEQ == data.SEQ)
      this.tableWorkFile[index].PART_NO = event.PART_NO
      this.tableWorkFile[index].PART_NAME = event.PART_NAME_EN
      this.tableWorkFile[index].UNIT_PRICE = event.AVERAGE_COST
      this.valid = false;
      this.tableWorkFile = this.tableWorkFile.slice();
    }
  }

  AcceptKitFlag() {

    let param = this.tableWorkFile.filter(x => x.PART_NO)
    param.map(x => {
      x.TD_ORDER_NO = this.ParamsDetailData.ORDER_NO
      x.TD_ORDER_ITEM_NO = this.ParamsDetailData.ORDER_ITEM_NO
      x.TD_SUB_ITEM_NO = this.ParamsDetailData.SUB_ITEM_NO
      x.TD_VENDOR_CODE = this.ParamsDetailData.VENDOR_CODE
      x.TD_VENDOR_TYPE = this.ParamsDetailData.VENDOR_TYPE
      x.TOT_QUANTITY = param.map(x => x.QUANTITY).reduce((prev, next) => prev + next, 0);
      x.TOT_AMOUNT = param.map(x => x.AMOUNT).reduce((prev, next) => prev + next, 0);
      x.REASON_CODE = this.ParamsWorkfile.REASON_CODE
      x.REASON_DESC = this.ParamsWorkfile.REASON_NAME_EN
    })


    this.http.post("AC", "SNPE018_M_AcceptKitFlag", param)
      .subscribe(res => {
        // console.log('res', res)
        this.dialogPart.Close()
      }, (err) => {
        console.log('err', err)

      })

  }
  Back() {
    this.dialogPart.Close()
  }


  FindHead(evt) {
    this.data.DOCUMENT_NO = evt.DOCUMENT_NO;
    this.FindHeadAuto();
    this.dialogDoc.Close();
  }

  BindData() {
    // console.log(this.data)
    if (this.data.vendor_type === 'J' || this.data.vendor_type === 'K') {
      this.data.TMP_TOT_IMP = this.data.TOTAL_NET_B;
    } else {
      this.data.TMP_TOT_IMP = "0";
    }
    if (this.data.vendor_type === 'J' || this.data.vendor_type === 'K') {
      this.data.TMP_TOT_LOC = this.data.TOTAL_NET_B;
    } else {
      this.data.TMP_TOT_LOC = "0";
    }
    if (this.data.CONFIRM_DATE === null || this.data.CONFIRM_DATE === "") {
      this.DisableSave = false;
    } else {
      this.DisableSave = true;
    }

    if (this.data.CONFIRM_DATE !== null && this.data.CONFIRM_DATE !== "" && this.data.STATUS_CODE === "60") {
      this.DisableCancel = false;
    }
    else {
      this.DisableCancel = true;
    }
    this.data.TMP_INV_NO = this.data.REF_INV_NO;
    this.data.TMP_INV_DATE = this.data.REF_INV_DATE;
    if (this.data.LAST_UPD_BY !== "" && this.data.LAST_UPD_BY !== null) {
    }
    if (this.data.VENDOR_TYPE === "K" || this.data.VENDOR_TYPE === "J") {
      this.data.TMP_TOT_IMP = this.data.TOTAL_NET_B;
    } else {
      this.data.TMP_TOT_LOC = this.data.TOTAL_NET_B;
    }
    if (this.data.ATTRIBUTE5 === null) {
      this.data.ATTRIBUTE5 = this.data.COMPANY_CODE;
    }

    if(!this.data.BUSINESS_PLACE){
      this.data.BUSINESS_PLACE = '00000'
    }

    if(!this.data.SUB_DOC_NO){
      this.data.SUB_DOC_NO = "-"
    }


    this.ConfigVat2.SourceParams.INV_DATE = this.data.REF_INV_DATE
    this.http.get("AC", "SNPE024_M_GetDocPart", this.data.DOCUMENT_TYPE, this.data.DOCUMENT_NO)
      .subscribe(result => {
        this.PartListData = result.Table;
        
        if(!this.DisableSave){
          this.autocompleteVat.textInput = this.data.VAT_CODE
          this.autocompleteVat.query();
        } else {
          setTimeout(() => {
            this.data.WHT_AMOUNT = 0;
            this.PartListData.forEach(x => {
               
              this.data.WHT_AMOUNT += x.AMOUNT * this.data.TAX_RATE
            });
          }, 100);
        }

        setTimeout(() => {
          if (this.data.vendor_type === 'J' || this.data.vendor_type === 'K') {
            this.data.TMP_TOT_IMP = this.data.TOTAL_NET_B;
            this.data.TMP_TOT_LOC = "0";
          } else {
            this.data.TMP_TOT_IMP = "0";
            this.data.TMP_TOT_LOC = this.data.TOTAL_NET_B;
          }
        }, 100);

      });
  }

  FindHeadAuto() {
    this.http.get("AC", "SNPE024_M_GetDocDesc", this.data.DOCUMENT_TYPE, this.data.DOCUMENT_NO)
      .subscribe(result => {
        this.data = result.Table[0];
        //console.log('this.data : ', this.data);
        this.BindData();
      });
  }
  FindDate(evt) {
    this.data.DOCUMENT_DATE = evt.DOCUMENT_DATE;
    this.dialogDate.Close();
  }
  FindVat(evt) {
    this.data.DEST_PORT = evt.VAT_CODE;
    this.dialogVat.Close();
  }



  FindInvo(evt) {
    this.data.REF_INV_NO = evt.INVOICE_NO;
    this.dialogInvo.Close();
  }
  FindInvoAuto(evt, p) {
    if (p === "a") {
      this.data.REF_INV_NO = evt.INVOICE_NO;
      this.data.REF_INV_DATE = evt.INVOICE_DATE;
    }

    if (p === "s") {
      this.ParamsSearch.INVOICE_NO = evt.INVOICE_NO;
    }

  }
  FindCom(evt) {
    this.data.ATTRIBUTE5 = evt.SK_SYSTEM_ID;
    this.data.VENDOR_NAME_TH = evt.TNAME;
    this.dialogCom.Close();
  }
  OpenDocDialog() {
    this.http.post("AC", "SNPE024_M_GetDoc", this.data)
      .subscribe(result => {
        this.sDocData = result.Table;
        this.dialogDoc.title = "Document No";
        this.dialogDoc.OpenDialog();
      });
  }

  keyupCal(val1, data) {
    if (data.QUANTITY !== undefined && val1 !== undefined) {
      if (val1 === "") {
        data.AMOUNT = 0;
      } else {
        data.AMOUNT = parseFloat(val1) * parseFloat(data.QUANTITY);
      }

    }
    this.PartListData = [...this.PartListData];
    this.data.TOTAL_NET_B = 0
    this.data.TOTAL_VAT = 0
    this.PartListData.forEach(x => {
      this.data.TOTAL_NET_B += x.AMOUNT
      this.data.TOTAL_VAT += x.AMOUNT * (this.data.VAT_RATE / 100);
    });

    setTimeout(() => {
      if (this.data.vendor_type === 'J' || this.data.vendor_type === 'K') {
        this.data.TMP_TOT_IMP = this.data.TOTAL_NET_B;
        this.data.TMP_TOT_LOC = "0";
      } else {
        this.data.TMP_TOT_IMP = "0";
        this.data.TMP_TOT_LOC = this.data.TOTAL_NET_B;
      }
    }, 100);
  }

  OpenDateDialog() {
    var p_date = null;
    if (this.data.DOCUMENT_DATE !== null) {
      p_date = this.data.DOCUMENT_DATE.toISOString().substring(0, 10);
    }
    this.http.get("AC", "SNPE024_M_GetDate", p_date)
      .subscribe(result => {
        this.sVatData = result.Table;
        this.dialogDoc.title = "Document Date";
        this.dialogDate.OpenDialog();
      });
  }
  OpenVatDialog() {
    this.http.get("AC", "SNPE024_M_GetVat")
      .subscribe(result => {
        this.sDateData = result.Table;
        this.dialogVat.title = "Vat";
        this.dialogVat.OpenDialog();
      });
  }
  OpenInvoDialog() {
    this.http.get("AC", "SNPE024_M_GetInv", null, this.data.VENDER_CODE, null)
      .subscribe(result => {
        this.sInvoData = result.Table;
        this.dialogInvo.title = "Invoice";
        this.dialogInvo.OpenDialog();
      });
  }
  OpenComDialog() {
    this.http.get("AC", "SNPE024_M_GetCom")
      .subscribe(result => {
        this.sComData = result.Table;
        this.dialogCom.title = "Company";
        this.dialogCom.OpenDialog();
      });
  }
  Save() {
    this.modal.confirm('Do you want to save change you have made?', this.viewref, this.ConfirmSave)
  }
  ConfirmSave = () => {
    this.data.CREATE_DATE = new Date();
    this.data.LAST_UPD_DATE = new Date();
    this.data.LAST_IP_ADDR = this.global.GetTokenDetail("ssIPAddress");
    this.http.post('AC', 'SNPE024_M_Save', this.data)
      .subscribe(res => {
        if (res.Table[0].STATUS === "DONE") {
          this.ngOnInit();
          this.modal.info('Transaction complete: applied and saved.', this.viewref);
          this.FindHeadAuto();
        }
        else if(res.Table[0].STATUS == 'CONFIRMED'){
          this.modal.warning('Someone is working on this document, please try again later',this.viewref)
        }
        else{
          this.modal.error('Found an error, please contract support team', this.viewref);
        }
      },err => {
          this.modal.error('Found an error, please contract support team', this.viewref);
      });
  }

  KitFlagIsY(data) {
    this.tblFooterWorkFile[2].value = 0;
    this.tableWorkFile = [];
    this.ParamsDetailData = data;
    if (!this.ParamsHeadData.CONFIRM_DATE) {
      this.http.post("AC", "SNPE018_M_GetWorkfile", this.ParamsDetailData)
        .subscribe(res => {
          // console.log('ressss', res)
          if (res.Table.length == 0) {
            let i = 0;
            while (i < 3) {
              this.tableWorkFile.push({
                PART_NAME: null,
                PART_NO: null,
                QUANTITY: null,
                REASON_CODE: null,
                ITEM_NO: i + 1,
                TMP_DOC_DATE: null,
                TMP_DOC_NO: null,
                UNIT_PRICE: null,
                AMOUNT: 0
              })
              i++;
            }

            this.ParamsWorkfile.TMP_DOC_NO = "New SK";
            this.ParamsWorkfile.TMP_DOC_DATE = new Date();
          } else {
            this.tableWorkFile = res.Table
            this.ParamsWorkfile.TMP_DOC_NO = "New SK"
            this.ParamsWorkfile.TMP_DOC_DATE = new Date();
          }
          this.dialogPart.OpenDialog();
     
        })
    } else {
      if (this.ParamsDetailData.SUB_DOC_NO) {
        this.http.post("AC", "SNPE018_M_GetTranDetailWorkfile", this.ParamsDetailData)
          .subscribe(res => {
            this.tableWorkFile = res.Table
            this.ParamsWorkfile.TMP_DOC_NO = res.Table[0].TMP_DOC_NO
            this.ParamsWorkfile.TMP_DOC_DATE = res.Table[0].TMP_DOC_DATE
            // console.log('res2', res)
          }, (err) => {
            console.log(err, 'err')
          })
      }
      this.dialogPart.OpenDialog();
    }
    //this.dialogPart.OpenDialog();
  }

  AddRow() {
    this.tableWorkFile.push({
      PART_NAME: null,
      PART_NO: null,
      QUANTITY: null,
      REASON_CODE: null,
      ITEM_NO: this.tableWorkFile.length + 1,
      TMP_DOC_DATE: null,
      TMP_DOC_NO: null,
      UNIT_PRICE: null,
      AMOUNT: 0
    })
    this.tableWorkFile = this.tableWorkFile.slice();
  }

  QuantityChange(oldValue, event, data) {
    // console.log('eeee',oldValue,event,data)
    let param = {
      PART_NO: data.PART_NO,
      QUANTITY: data.QUANTITY
    }
    this.http.post("AC", "SNPE018_M_CheckQty", param)
      .subscribe(res => {
        // console.log(res)
        if (res.Table[0].STATUS == 'Fail') {
          this.modal.error(res.Table[0].MSG, this.viewref);
          this.valid = false;
        } else {
          this.valid = true;
        }
        this.tblFooterWorkFile[2].value = this.tableWorkFile.map(x => x.AMOUNT).reduce((prev, next) => prev + next);
        this.tableWorkFile = this.tableWorkFile.slice();
      })

    //this.tblFooterWorkFile.slice()
  }

  Cancel() {
    this.modal.confirm('Are you sure to cancel this document?', this.viewref, this.ConfirmCancel)
  }
  ConfirmCancel = () => {
    this.data.LAST_IP_ADDR = this.global.GetTokenDetail("ssIPAddress");
    this.http.post('AC', 'SNPE024_M_Cancle', this.data)
      .subscribe(res => {
        if (res.Table[0].STATUS === "DONE") {
          this.ngOnInit();
          this.modal.info('Transaction complete: applied and saved.', this.viewref);
          this.FindHeadAuto();
        }
      });
  }

  SelectedVatCode(event){

    this.data.DEST_PORT = event.VAT_CODE;
    this.data.VAT_DESC = event.VAT_DESC;
    this.data.VAT_FLAG = event.VAT_FLAG;
    this.data.VAT_RATE = event.VAT_RATE;
    this.data.TAX_FLAG = event.TAX_FLAG;
    this.data.TAX_RATE = event.TAX_RATE;

    this.data.TOTAL_NET_B = 0
    this.data.TOTAL_VAT = 0
    this.data.WHT_AMOUNT = 0

    setTimeout(() => {
      this.PartListData.forEach(x => {
        this.data.TOTAL_NET_B += x.AMOUNT
        this.data.TOTAL_VAT += x.AMOUNT * (this.data.VAT_RATE / 100);
        this.data.WHT_AMOUNT += x.AMOUNT * (this.data.TAX_RATE / 100);
      });
    }, 100);

  }
}
