import { Component, OnInit,ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';

@Component({
    selector: 'snsq092',
    templateUrl: './SNSQ092.component.html',
    styleUrls: ['./SNSQ092.component.css']
})



export class SNSQ092Component implements OnInit {


    constructor(
        private http: HttpService,
        private viewref: ViewContainerRef,
        private modal: ModalService
    ) { }

  public data: any;
  public CustomerList: any = [];
  public ParamSearch: any = {};
  public tableData: any = [];
  public totalRecord = 0;
  public PROCESS_LOG: any = [];


  ngOnInit() { 

  }

  public ConfigPartNo: any = {
    ColName: "LOOKUP_PART_NO",
    ColValue: "",
    PlaceholderText: "Select Part No",
    SourceController: "SL",
    SourceMethodName: "SNSQ092_GetPartNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public ConfigCustomerCode: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    ColValue: "",
    PlaceholderText: "Select Customer Code",
    SourceController: "SL",
    SourceMethodName: "SNSQ092_GetCustomerCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public ConfigOrderNo: any = {
    ColName: "ORDER_NO",
    ColValue: "",
    PlaceholderText: "Select Order No",
    SourceController: "SL",
    SourceMethodName: "SNSQ092_GetOrderNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: false
  }

 
  public Search() {
    console.log(this.ParamSearch)
    this.tableData = [];
    this.http.post("SL", "SNSQ092_GET_LIST", this.ParamSearch)
      .subscribe(res => {
        this.tableData = res.Table;
        this.totalRecord = this.tableData.length
      })
  }

  public ExportExcel() {
    this.http.Download("SL", "SNSQ092_Export_Excle", JSON.stringify(this.tableData))
      .subscribe(res => {
        if (res) {
          this.WriteContents(res)
          this.PROCESS_LOG.push('Export complete ' + this.tableData.length + ' records.');
        } else {
          this.modal.error('Download not complete', this.viewref)
        }
      })
  }

  private WriteContents(content) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    var date_export = new Date();
    a.href = URL.createObjectURL(file);
    a.download = "SNSQ092" + "_" + date_export.getFullYear() + (date_export.getMonth() + 1) + date_export.getDate() + ".csv";
    a.click();
  }


}
