import { Component, OnInit, ViewEncapsulation, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { FormGroup, FormControl, FormBuilder } from '@angular/forms'
import { Router } from '@angular/router';
import { Observable, config } from 'rxjs';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from 'src/app/core/global';
import * as moment from 'moment';

@Component({
  selector: 'snse053_m',
  templateUrl: './SNSE053_M.component.html',
  styleUrls: ['./SNSE053_M.component.css'],
  encapsulation: ViewEncapsulation.None
})



export class SNSE053_MComponent implements OnInit {


  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    private global: Globals,
    private router: Router
  ) { }

  public CustomerList: any;

  public tableData: any = [];
  public dataSelected: any = [];

  public tableData2: any = [];
  public tableData2All: any = [];

  public tableData3: any = [];
  public tableData4: any = [];
  public tableData4All: any = [];

  public tableData5: any = [];
  public dataSelected5: any = [];
  public formData: any = {};
  public dataHeader: any = {};

  public tableName: string;
  public show: boolean = true;
  public params: any = {};

  public selectCase: any = {};
  public selectCase5: any = {};

  public activeCase: any = {};
  public activeCase2: any = {};


  public tblFooter: any = [
    {
      fieldName: "NB_DG",
      value: "Total",
      show: true
    },
    {
      fieldName: "GROSS_WEIGHT",
      
      show: true
    },
    {
      fieldName: "GROSS_MM",
      
      show: true
    },
    {
      fieldName: "PACK_QTY",
      
      show: true
    },
    {
      fieldName: "ACCEPT_QTY",
      
      show: true
    }

  ]

  public tblFooter2: any = [
    {
      fieldName: "SUB_ITEM_NO",
      value: "Total",
      show: true
    },
    {
      fieldName: "PACK_QTY",
      
      show: true
    },
    {
      fieldName: "ACCEPT_QTY",
      
      show: true
    }

  ]

  public docDate: any;

  ngOnInit() {
    this.docDate = new Date();
  }



  public lookupCustomerCodeConfig: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    PlaceholderText: "Select Customer Code",
    SourceController: "SL",
    SourceMethodName: "SNSE053_GetCustomerCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetSelectedCustomerCode(values: any) {
    this.params.CUSTOMER_CODE = values.CUSTOMER_CODE;
    this.params.CUSTOMER_NAME = values.CUSTOMER_NAME;


    this.params.BRANCH_CODE = values.BRANCH_CODE;
    this.params.BRANCH_NAME = values.BRANCH_NAME;


    this.params.COUNTRY = values.COUNTRY;
    this.params.CURRENCY_CODE = values.CURRENCY_CODE;
    this.params.PAYMENT_TERM = values.PAYMENT_TERM;
    this.params.EXCHANGE_RATE = values.EXCHANGE_RATE;

    this.GetData();
  }


  Search = () => {

    this.http.post('SL', 'SNSE053_GetData', this.params)
      .subscribe(res => {
        this.dataHeader = res.Table[0];

        this.formData.LAST_UPD_BY_NAME = this.tableData[0].LAST_UPD_BY_NAME;
        this.formData.LAST_UPD_DATE = this.tableData[0].LAST_UPD_DATE;
      })
  }

  private GetData = () => {
    this.tableData = null;
    this.http.post('SL', 'SNSE053_GetData', this.params)
      .subscribe(res => {
        this.tableData = res.Table;
        this.tableData2 = res.Table1;
        this.tableData2All = res.Table1;

        this.tableData3 = res.Table2;
        this.tableData4 = res.Table3;
        this.tableData4All = res.Table3;
        this.tableData5 = res.Table;
        this.ProcessCondition();
      })
  }

  CheckToPack(event, data) {

    this.selectCase.TotolCase = 0;
    this.selectCase.TotolSelect = 0;

    this.dataSelected = this.tableData.filter(v => v.CHK_BOX === true);

    this.dataSelected.forEach((value) => {

      this.selectCase.TotolCase = this.selectCase.TotolCase + 1;
      this.selectCase.TotolSelect = this.selectCase.TotolSelect + value.PACK_QTY;


    });

    this.selectCase5.TotolCase = 0;
    this.selectCase5.TotolSelect = 0;
    this.dataSelected5 = this.tableData.filter(v => v.CHK_BOX === true);
    this.dataSelected5.forEach((value) => {
      this.selectCase5.TotolCase = this.selectCase5.TotolCase + 1;
      this.selectCase5.TotolSelect = this.selectCase5.TotolSelect + value.PACK_QTY;
    });
  }

  public CheckPrintChange(value) {
    if (value.checked == true) {
      this.params.ATTACH_SHEET = 'Y'
    }
    else {
      this.params.ATTACH_SHEET = 'N'
    }
  }

  public ConfirmPre() {

    this.dataSelected = this.tableData.filter(v => v.CHK_BOX === true);

    //console.log('dataSelected :', this.dataSelected);
    if (this.selectCase.TotolCase == 0) {
      this.modal.warning("Found an error, please contract support team", this.viewRef);
    }

    this.modal.confirm("Are you sure to confirm Pre-invoice ?", this.viewRef,
      () => {

        this.http.post("SL", "SNSE053_ConfirmPre", JSON.stringify(this.dataSelected))
          .subscribe(result => {
            if (result.substring(0, 4) == "DONE") {
              this.GetData();
              this.modal.info("Confirm successfully [Pre-Invoice no.] : " + result.substring(5, 14), this.viewRef);
       
              if (this.params.ATTACH_SHEET == 'Y') {
                this.OpenReport(result.substring(5, 14));
              }
            } else {
              this.GetData();
              this.modal.warning("Found an error, please contract support team", this.viewRef);
            }
          }, (err) => {
            this.GetData();
            console.log(err, 'err')
            this.modal.warning("Found an error, please contract support team", this.viewRef);
          })


      }, () => { })

  }

  public ModifyPre() {

    //if (this.selectCase.TotolCase == 0) {
    //  this.modal.warning("Found an error, please contract support team", this.viewRef);
    //}

    this.modal.confirm("Are you sure to modify Pre-invoice ?", this.viewRef,
      () => {

        this.http.post("SL", "SNSE053_ModifyPre", JSON.stringify(this.tableData3))
          .subscribe(result => {
            if (result == "DONE") {
              this.GetData();
              this.modal.info("Confirm operation successfully : " + result, this.viewRef);
            } else {
              this.GetData();
              this.modal.warning("Found an error, please contract support team", this.viewRef);
            }
          }, (err) => {
            console.log(err, 'err');
            this.GetData();
            this.modal.warning("Found an error, please contract support team", this.viewRef);
          })


      }, () => { })

  }

  public ConfirmDelete() {

    this.dataSelected5 = this.tableData5.filter(v => v.CHK_BOX === true);

    //console.log('dataSelected :', this.dataSelected);
    if (this.selectCase.TotolCase == 0) {
      this.modal.warning("Found an error, please contract support team", this.viewRef);
    }

    this.modal.confirm("Are you sure to delete case?", this.viewRef,
      () => {

        this.http.post("SL", "SNSE032_ConfirmDelete", JSON.stringify(this.dataSelected5))
          .subscribe(result => {
            if (result.substring(0, 4) == "DONE") {
              this.GetData();
              this.modal.info("Delete case successfully", this.viewRef);
            } else {
              this.GetData();
              this.modal.warning("Found an error, please contract support team", this.viewRef);
            }
          }, (err) => {
            this.GetData();
            console.log(err, 'err')
            this.modal.warning("Found an error, please contract support team", this.viewRef);
          })


      }, () => { })

  }











  private ProcessCondition() {

    var countError = 0;
    this.tableData.forEach((value) => {

      if (value.GROSS_WEIGHT == '' && value.GROSS_WEIGHT > 0) {
        if (value.NET_WEIGHT > value.GROSS_WEIGHT) {
          value.CHK_BOX = false;
          value.ERROR = 1;
          value.REMARK = 'GW error';
          countError = countError + 1;
          value.CHECK = 0;
        }
        else {
          value.CHK_BOX = true;
          value.SELECT = value.ACCEPT_QTY;
          value.CHECK = 1;
        }
      }
      else {
        value.CHK_BOX = true;
        value.SELECT = value.ACCEPT_QTY;
        value.CHECK = 1;
      }

    });

    this.selectCase.TotalError = countError;

    var event;
    var data;
    this.CheckToPack(event, data)

  }


  public onClickRow(data) {

    this.tableData2 = this.tableData2All.filter(v => v.CASE_NO === data.CASE_NO);
    this.activeCase.CASE_NO = data.CASE_NO;
    this.activeCase.PACK_DATE = data.PACK_DATE;
    this.activeCase.PACK_TIME = data.PACK_TIME;
    this.activeCase.PACK_BY = data.PACK_BY;
    this.activeCase.GROSS_MM = data.GROSS_MM;
    this.activeCase.GROSS_WEIGHT = data.GROSS_WEIGHT;
    this.activeCase.PACK_QTY = data.PACK_QTY;
    this.activeCase.ACCEPT_QTY = data.ACCEPT_QTY;

  }

  public onClickRow3(data) {

    this.tableData4 = this.tableData4All.filter(v => v.CASE_NO === data.CASE_NO);
    this.activeCase2.CASE_NO = data.CASE_NO;
    this.activeCase2.PACK_DATE = data.PACK_DATE;
    this.activeCase2.PACK_TIME = data.PACK_TIME;
    this.activeCase2.PACK_BY = data.PACK_BY;
    this.activeCase2.GROSS_MM = data.GROSS_MM;
    this.activeCase2.GROSS_WEIGHT = data.GROSS_WEIGHT;
    this.activeCase2.PACK_QTY = data.PACK_QTY;
    this.activeCase2.ACCEPT_QTY = data.ACCEPT_QTY;

  }

  private OpenReport(preInovice) {
    this.global.GoToReport("PMS_RPT_SALES_SNSE032R_N", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_CUST_S: this.params.CUSTOMER_CODE,
      P_CUST_E: this.params.CUSTOMER_CODE,
      P_PINV_NO_START: preInovice,
      P_PINV_NO_END: preInovice,
      P_PINV_DATE_S: moment(this.docDate).format('DD-MMM-YY'),
      P_PINV_DATE_E: moment(this.docDate).format('DD-MMM-YY'),
      P_SENT_BY: 'S'
    })
  }
}
