import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { FormControl, Validators } from '@angular/forms';
import { ModalService } from 'src/app/core/modal.service';
import { SelectionModel } from '@angular/cdk/collections';


import { MomentDateAdapter, MAT_MOMENT_DATE_ADAPTER_OPTIONS } from '@angular/material-moment-adapter';
import { DateAdapter, MAT_DATE_FORMATS, MAT_DATE_LOCALE } from '@angular/material/core';
import { MatDatepicker } from '@angular/material/datepicker';
import * as _moment from 'moment';
import * as _rollupMoment from 'moment';
import { Moment } from 'moment';

const moment = _rollupMoment || _moment;

export const MY_FORMATS = {
  parse: {
    dateInput: 'MM/YYYY',
  },
  display: {
    dateInput: 'MM/YYYY',
    monthYearLabel: 'MMM YYYY',
    dateA11yLabel: 'LL',
    monthYearA11yLabel: 'MMMM YYYY',
  },
};


@Component({
  selector: 'snsq074e',
  templateUrl: './SNSQ074E.component.html',
  styleUrls: ['./SNSQ074E.component.css'],

})


export class SNSQ074EComponent implements OnInit {

  public params = {
    FROM_DATE: null,
    TO_DATE: null,
    EXCHANGE_RATE: null,
    BUYER_CODE: null,
    BUYER_NAME: null,
    BRANCH_CODE: null,
    BRANCH_NAME: null,
    EFFECTIVE_DATE: null,
    DATA_MONTH: null,
    CURRENCY: null
  }



  constructor(
    private Http: HttpService,
    private router: Router,
    private global: Globals,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) { }

  public tableData1 = {
    T_PART_SALE: null,
    T_PART_GP: null,
    T_GPR_PARTS_PERCENT: null,
    T_ACC_SALE: null,
    T_ACC_GP: null,
    T_GPR_ACC_PERCENT: null,
    T_ACC_DLR_OPT_SALE: null,
    T_ACC_DLR_OPT_SALE_GP: null,
    T_ACC_PDI_SALE: null,
    T_ACC_PDI_SALE_GP: null,
    T_EXP_SALES: null,
    T_EXP_GP: null,
    T_GPR_PERCENT: null,
    OP_PART_SALE: null,
    OP_PART_GP: null,
    OP_GPR_PART_PERCENT: null,
    OP_ACC_SALE: null,
    OP_ACC_GP: null,
    OP_GPR_ACC_PERCENT: null,
    OP_EXP_SALES: null,
    OP_EXP_GP: null,
    OP_T_GPR_PERCENT: null,
    BP_PART_SALE: null,
    BP_PART_GP: null,
    BP_GPR_PART_PERCENT: null,
    BP_ACC_SALE: null,
    BP_ACC_GP: null,
    BP_GPR_ACC_PERCENT: null,
    BP_EXP_SALES: null,
    BP_EXP_GP: null,
    BP_T_GPR_PERCENT: null,
    ATT_PART_SALE: null,
    ATT_PART_GP: null,
    ATT_GPR_PART_PERCENT: null,
    ATT_ACC_SALE: null,
    ATT_ACC_GP: null,
    ATT_GPR_ACC_PERCENT: null,
    ATT_EXP_SALES: null,
    ATT_EXP_GP: null,
    ATT_T_GPR_PERCENT: null
  }
  public tableData2: any;
  public tableData3: any;
  public tableData4: any;

  public tableExport: any = {};

  public tblFooter2: any = [
    {
      fieldName: "Cif_CURRENCY",
      value: null,
      show: true
    },
    {
      fieldName: "Cif_BAHT",
      value: null,
      show: true
    },
    {
      fieldName: "Cif_MBAHT",
      value: null,
      show: true
    }
  ]

  public totalRecord2: any = 0;
  public totalRecord3: any = 0;

  public IsSelectTab: any = 0;

  public DataIsSelected: any;
  public DataIsSelected2: any;
  public selection = new SelectionModel<any>(true, []);
  public selection2 = new SelectionModel<any>(true, []);

  ngOnInit() {
    this.params.FROM_DATE = new Date();
    this.params.TO_DATE = new Date();
    this.params.EFFECTIVE_DATE = new Date();
    this.params.DATA_MONTH = new Date();
    this.params.EXCHANGE_RATE = 0;
  }

  initData() {
    //this.tableData1 = {
    //  T_PART_SALE: 0,
    //  T_PART_GP: 0,
    //  T_GPR_PARTS_PERCENT: 0,
    //  T_ACC_SALE: 0,
    //  T_ACC_GP: 0,
    //  T_GPR_ACC_PERCENT: 0,
    //  T_ACC_DLR_OPT_SALE: 0,
    //  T_ACC_DLR_OPT_SALE_GP: 0,
    //  T_ACC_PDI_SALE: 0,
    //  T_ACC_PDI_SALE_GP: 0,
    //  T_EXP_SALES: 0,
    //  T_EXP_GP: 0,
    //  T_GPR_PERCENT: 0,
    //  OP_PART_SALE: 0,
    //  OP_PART_GP: 0,
    //  OP_GPR_PART_PERCENT: 0,
    //  OP_ACC_SALE: 0,
    //  OP_ACC_GP: 0,
    //  OP_GPR_ACC_PERCENT: 0,
    //  OP_EXP_SALES: 0,
    //  OP_EXP_GP: 0,
    //  OP_T_GPR_PERCENT: 0,
    //  BP_PART_SALE: null,
    //  BP_PART_GP: 0,
    //  BP_GPR_PART_PERCENT: 0,
    //  BP_ACC_SALE: 0,
    //  BP_ACC_GP: 0,
    //  BP_GPR_ACC_PERCENT: 0,
    //  BP_EXP_SALES: 0,
    //  BP_EXP_GP: 0,
    //  BP_T_GPR_PERCENT: 0,
    //  ATT_PART_SALE: 0,
    //  ATT_PART_GP: 0,
    //  ATT_GPR_PART_PERCENT: 0,
    //  ATT_ACC_SALE: 0,
    //  ATT_ACC_GP: 0,
    //  ATT_GPR_ACC_PERCENT: 0,
    //  ATT_EXP_SALES: 0,
    //  ATT_EXP_GP: 0,
    //  ATT_T_GPR_PERCENT: 0
    //}
    this.tableData2 = null;
    this.tableData3 = null;
    this.totalRecord2 = 0;
    this.totalRecord3 = 0;
    this.DataIsSelected = [];
    this.DataIsSelected2 = [];
  }

  public lookupBuyerCodeConfig: any = {
    ColName: "LOOKUP_BUYER_CODE",
    PlaceholderText: "Select Buyer Code",
    SourceController: "SL",
    SourceMethodName: "SNSQ074E_GetBuyerCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public lookupBranchCodeConfig: any = {
    ColName: "LOOKUP_BRANCH_CODE",
    PlaceholderText: "Select Branch Code",
    SourceController: "SL",
    SourceMethodName: "SNSQ074E_GetBranchCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params
    },
    UpperCase: true
  }

  public SetSelectedBuyerCode(values: any) {
    this.params.BUYER_CODE = values.BUYER_CODE;
    this.params.BUYER_NAME = values.BUYER_NAME;
    this.params.BRANCH_CODE = null;
    this.params.BRANCH_NAME = null;
  }

  public SetSelectedBranchCode(values: any) {
    this.params.BRANCH_CODE = values.BRANCH_CODE;
    this.params.BRANCH_NAME = values.BRANCH_NAME;
  }

  Search = () => {
    this.initData();
    this.Http.post('SL', 'SNSQ074E_GetSummary', this.params)
      .subscribe(res => {
        this.tableData1 = res.Table[0];
        this.tableExport = res.Table;
      })
    this.Http.post('SL', 'SNSQ074E_GetInvoiceDetail', this.params)
      .subscribe(res => {
        this.tableData2 = res.Table;
        this.totalRecord2 = this.tableData2.length;
      })
    this.Http.post('SL', 'SNSQ074E_GetPickingDetail', this.params)
      .subscribe(res => {
        this.tableData3 = res.Table;
        this.totalRecord3 = this.tableData3.length;
      })
  }

  isAllSelected() {
    const numSelected = this.selection.selected.length;
    const numRows = this.tableData2.length;
    return numSelected === numRows;
  }

  Toggle() {
    if (this.isAllSelected()) {
      this.selection.clear()
      this.tableData2.map(x => {
        this.DataIsSelected = [];

      })
    } else {
      this.tableData2.forEach(row => this.selection.select(row));
      this.DataIsSelected = [];
      this.tableData2.map(x => {
        this.DataIsSelected.push(x);
      })
    }
  }

  CheckboxChange(event, data) {
    if (event.checked) {
      this.DataIsSelected.push(data);
    }
    else {
      this.DataIsSelected.splice(this.DataIsSelected.indexOf(data), 1);
    }
  }

  isAllSelectedPick() {
    const numSelected = this.selection2.selected.length;
    const numRows = this.tableData3.length;
    return numSelected === numRows;
  }

  TogglePick() {
    if (this.isAllSelectedPick()) {
      this.selection2.clear()
      this.tableData3.map(x => {
        this.DataIsSelected2 = [];

      })
    } else {
      this.tableData3.forEach(row => this.selection2.select(row));
      this.DataIsSelected2 = [];
      this.tableData3.map(x => {
        this.DataIsSelected2.push(x);
      })
    }
  }

  CheckboxChangePick(event, data) {
    if (event.checked) {
      this.DataIsSelected2.push(data);
    }
    else {
      this.DataIsSelected2.splice(this.DataIsSelected2.indexOf(data), 1);
    }
  }

  SearchExchange = () => {
    this.Http.post("SL", "SNSQ074E_GetExchangeRateDetail", this.params)
      .subscribe(res => {
        this.tableData4 = res.Table;
      })
  }

  addExchangeRate() {
    if (this.params.CURRENCY && (this.params.EXCHANGE_RATE != null || this.params.EXCHANGE_RATE != '')) {
      if (this.params.EXCHANGE_RATE == 0) {
        this.modal.warning('Are you sure to add Exchange rate = 0.000?', this.viewref);
      } else {
        this.Http.post('SL', 'SNSQ074E_AddExchangeRate', this.params)
          .subscribe(res => {
            console.log(res)
            if (res.Table[0].STATUS === "DONE") {
              this.modal.info('Transaction complete: applied and saved.', this.viewref);
              this.SearchExchange();
            }
          });
      }
    }
    else {
      this.modal.warning('Please fill data', this.viewref);
    }
  }

  tabClick(tab: any) {
    this.IsSelectTab = tab;
  }


  ExportExcel() {
    var ctrName = "";
    var type = "";
    var data = [];
    if (this.IsSelectTab == 0) {
      if (this.tableExport) {
        ctrName = "SNSQ074E_SummaryExport";
        type = "SUMMARY";
        data = this.tableExport;
      }
      else {
        this.modal.warning('Cannot export to excel on empty value', this.viewref);
      }
    }
    else if (this.IsSelectTab == 1) {
      if (this.tableData2) {
        ctrName = "SNSQ074E_InvoiceExport";
        type = "INOVICE";
        data = this.tableData2;
      }
      else {
        this.modal.warning('Cannot export to excel on empty value', this.viewref);
      }

    }
    else if (this.IsSelectTab == 2) {
      if (this.tableData3) {
        ctrName = "SNSQ074E_PickingExport";
        type = "PICKING";
        data = this.tableData3;
      }
      else {
        this.modal.warning('Cannot export to excel on empty value', this.viewref);
      }
    }
    else if (this.IsSelectTab == 3) {
      if (this.tableData4) {
        ctrName = "SNSQ074E_ExchangeExport";
        type = "EXCHANGE";
        data = this.tableData4;
      }
      else {
        this.modal.warning('Cannot export to excel on empty value', this.viewref);
      }
    }
    if (ctrName && data) {
      this.Http.Download('SL', ctrName, JSON.stringify(data))
        .subscribe(res => {
          if (res) {
            this.WriteContents(res, type)
          } else {
            this.modal.error('Download not complete', this.viewref)
          }
        })
    }
  }

  WriteContents(content, type) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    a.href = URL.createObjectURL(file);
    a.download = "SNSQ074E_" + type + ".csv";
    a.click();
  }


  reCalculate() {
    //T
    this.tableData1.T_ACC_SALE = (this.tableData1.T_ACC_DLR_OPT_SALE || 0) + (this.tableData1.T_ACC_PDI_SALE || 0);
    this.tableData1.T_ACC_GP = (this.tableData1.T_ACC_DLR_OPT_SALE_GP || 0) + (this.tableData1.T_ACC_PDI_SALE_GP || 0);

    if (((this.tableData1.T_ACC_DLR_OPT_SALE_GP || 0) + (this.tableData1.T_ACC_PDI_SALE_GP || 0)) != 0) {
      this.tableData1.T_GPR_ACC_PERCENT = (((this.tableData1.T_ACC_DLR_OPT_SALE_GP || 0) + (this.tableData1.T_ACC_PDI_SALE_GP || 0)) / ((this.tableData1.T_ACC_DLR_OPT_SALE || 0) + (this.tableData1.T_ACC_PDI_SALE || 0))) * 100;
    }
    else {
      this.tableData1.T_GPR_ACC_PERCENT = null;
    };

    this.tableData1.T_EXP_SALES = (this.tableData1.T_PART_SALE || 0) + (this.tableData1.T_ACC_SALE || 0);
    this.tableData1.T_EXP_GP = (this.tableData1.T_PART_GP || 0) + (this.tableData1.T_ACC_GP || 0);

    if (((this.tableData1.T_PART_GP || 0) + (this.tableData1.T_ACC_GP || 0)) != 0) {
      this.tableData1.T_GPR_PERCENT = ((this.tableData1.T_PART_GP + this.tableData1.T_ACC_GP || 0) / (this.tableData1.T_PART_SALE + this.tableData1.T_ACC_SALE || 0)) * 100;
    }
    else {
      this.tableData1.T_GPR_PERCENT = null;
    };

    //On process
    if ((this.tableData1.OP_PART_SALE || 0) != 0) {
      this.tableData1.OP_GPR_PART_PERCENT = ((this.tableData1.OP_PART_GP || 0) / (this.tableData1.OP_PART_SALE || 0)) * 100;
    }
    else {
      this.tableData1.OP_GPR_PART_PERCENT = null;
    };

    if (this.tableData1.OP_ACC_SALE != 0) {
      this.tableData1.OP_GPR_ACC_PERCENT = ((this.tableData1.OP_ACC_GP || 0) / (this.tableData1.OP_ACC_SALE || 0)) * 100;
    }
    else {
      this.tableData1.OP_GPR_ACC_PERCENT = null;
    };

    this.tableData1.OP_EXP_SALES = (this.tableData1.OP_PART_SALE || 0) + (this.tableData1.OP_ACC_SALE || 0);
    this.tableData1.OP_EXP_GP = (this.tableData1.OP_PART_GP || 0) + (this.tableData1.OP_ACC_GP || 0);

    if (((this.tableData1.OP_PART_GP || 0) + (this.tableData1.OP_ACC_GP || 0)) != 0) {
      this.tableData1.OP_T_GPR_PERCENT = (((this.tableData1.OP_PART_GP || 0) + (this.tableData1.OP_ACC_GP || 0)) / ((this.tableData1.OP_PART_SALE || 0) + (this.tableData1.OP_ACC_SALE || 0))) * 100;
    }
    else {
      this.tableData1.OP_T_GPR_PERCENT = null;
    };

    //BP
    if ((this.tableData1.BP_PART_SALE || 0) != 0) {
      this.tableData1.BP_GPR_PART_PERCENT = ((this.tableData1.BP_PART_GP || 0) / (this.tableData1.BP_PART_SALE || 0)) * 100;
    }
    else {
      this.tableData1.BP_GPR_PART_PERCENT = null;
    };

    if ((this.tableData1.BP_ACC_SALE || 0) != 0) {
      this.tableData1.BP_GPR_ACC_PERCENT = ((this.tableData1.BP_ACC_GP || 0) / (this.tableData1.BP_ACC_SALE) || 0) * 100;
    }
    else {
      this.tableData1.BP_GPR_ACC_PERCENT = null;
    };

    this.tableData1.BP_EXP_SALES = (this.tableData1.BP_PART_SALE || 0) + (this.tableData1.BP_ACC_SALE || 0);
    this.tableData1.BP_EXP_GP = (this.tableData1.BP_PART_GP || 0) + (this.tableData1.BP_ACC_GP || 0);

    if (((this.tableData1.BP_PART_GP || 0) + (this.tableData1.OP_ACC_GP || 0)) != 0) {
      this.tableData1.BP_T_GPR_PERCENT = (((this.tableData1.BP_PART_GP || 0) + (this.tableData1.BP_ACC_GP || 0)) / ((this.tableData1.BP_PART_SALE || 0) + (this.tableData1.BP_ACC_SALE || 0))) * 100;
    }
    else {
      this.tableData1.BP_T_GPR_PERCENT = null;
    };

    //Att %
    console.log(this.tableData1.BP_PART_SALE)
    if ((this.tableData1.BP_PART_SALE || 0) != 0) {
      this.tableData1.ATT_PART_SALE = (((this.tableData1.T_PART_SALE || 0) + (this.tableData1.OP_PART_SALE || 0)) / (this.tableData1.BP_PART_SALE || 0)) * 100;
    }
    else {
      this.tableData1.ATT_PART_SALE = null;
    };

    if ((this.tableData1.BP_PART_GP || 0) != 0) {
      this.tableData1.ATT_PART_GP = (((this.tableData1.T_PART_GP || 0) + (this.tableData1.OP_PART_GP || 0)) / (this.tableData1.BP_PART_GP || 0)) * 100;
    }
    else {
      this.tableData1.ATT_PART_GP = null;
    };

    if ((this.tableData1.BP_GPR_PART_PERCENT || 0) != 0) {
      this.tableData1.ATT_GPR_PART_PERCENT = (((this.tableData1.T_GPR_PARTS_PERCENT || 0) + (this.tableData1.OP_GPR_PART_PERCENT || 0)) / (this.tableData1.BP_GPR_PART_PERCENT || 0)) * 100;
    }
    else {
      this.tableData1.ATT_GPR_PART_PERCENT = null;
    };

    if ((this.tableData1.BP_ACC_SALE || 0) != 0) {
      this.tableData1.ATT_ACC_SALE = (((this.tableData1.T_ACC_SALE || 0) + (this.tableData1.OP_ACC_SALE || 0)) / (this.tableData1.BP_ACC_SALE || 0)) * 100;
    }
    else {
      this.tableData1.ATT_ACC_SALE = null;
    };

    if ((this.tableData1.BP_ACC_GP || 0) != 0) {
      this.tableData1.ATT_ACC_GP = (((this.tableData1.T_ACC_GP || 0) + (this.tableData1.OP_ACC_GP || 0)) / (this.tableData1.BP_ACC_GP || 0)) * 100;
    }
    else {
      this.tableData1.ATT_ACC_GP = null;
    };

    if ((this.tableData1.BP_GPR_ACC_PERCENT || 0) != 0) {
      this.tableData1.ATT_GPR_ACC_PERCENT = (((this.tableData1.T_GPR_ACC_PERCENT || 0) + (this.tableData1.OP_GPR_ACC_PERCENT || 0)) / (this.tableData1.BP_GPR_ACC_PERCENT || 0)) * 100;
    }
    else {
      this.tableData1.ATT_GPR_ACC_PERCENT = null;
    };


    if ((this.tableData1.BP_EXP_SALES || 0) != 0) {
      this.tableData1.ATT_EXP_SALES = (((this.tableData1.T_EXP_SALES || 0) + (this.tableData1.OP_EXP_SALES || 0)) / (this.tableData1.BP_EXP_SALES || 0)) * 100;
    }
    else {
      this.tableData1.ATT_EXP_SALES = null;
    };

    if ((this.tableData1.BP_EXP_GP || 0) != 0) {
      this.tableData1.ATT_EXP_GP = (((this.tableData1.T_EXP_GP || 0) + (this.tableData1.OP_EXP_GP || 0)) / (this.tableData1.BP_EXP_GP || 0)) * 100;
    }
    else {
      this.tableData1.ATT_EXP_GP = null;
    };

    if ((this.tableData1.BP_T_GPR_PERCENT || 0) != 0) {
      this.tableData1.ATT_T_GPR_PERCENT = (((this.tableData1.T_GPR_PERCENT || 0) + (this.tableData1.OP_T_GPR_PERCENT || 0)) / (this.tableData1.BP_T_GPR_PERCENT || 0)) * 100;
    }
    else {
      this.tableData1.ATT_T_GPR_PERCENT = null;
    };
  }
}

