import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import * as moment from 'moment';

@Component({
  selector: 'snpr026_m',
  templateUrl: './snpr026_m.component.html',
  styleUrls: ['./snpr026_m.component.css']
})



export class SNPR026_MComponent implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    private global : Globals
  ) { }

  public ConfigDocType: any = {
    ColName: "DOCUMENT_TYPE",
    ColValue: "DOCUMENT_TYPE",
    PlaceholderText: "Select Document Type",
    SourceController: "AC",
    SourceMethodName: "SNPR026_M_GetDocType",
    NoOfShowRecords: 25,
    MinLengthSearch: 0,
    UpperCase: false
}


  public ConfigDocNO: any = {
    ColName: "DOCUMENT_NO",
    ColValue: "DOCUMENT_NO",
    PlaceholderText: "Select Document No",
    SourceController: "AC",
    SourceMethodName: "SNPR026_M_GetDocNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 5,
    UpperCase: false
  }

  public ConfigDocDate: any = {
    ColName: "DOCUMENT_DATE_LOOKUP",
    ColValue: "DOCUMENT_DATE",
    PlaceholderText: "Select Document Date",
    SourceController: "AC",
    SourceMethodName: "SNPR026_M_GetDocDate",
    NoOfShowRecords: 25,
    MinLengthSearch: 2,
    UpperCase: false,
    SourceParams: {
      DOC_NO_START: null,
      DOC_NO_END: null
    }
  }


  public Params = {
    DOCUMENT_TYPE_FROM : null,
    DOCUMENT_TYPE_TO : null,
    DOCUMENT_NO_FROM : null,
    DOCUMENT_NO_TO : null,
    DOCUMENT_DATE_FROM :moment(),
    DOCUMENT_DATE_TO : moment()
  }

  ngOnInit() {

  }

  OpenReport(){

    this.global.GoToReport("PMS_RPT_ACC_SNPR026R",
      {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_DOCUMENT_TYPE_FROM: this.Params.DOCUMENT_TYPE_FROM,
        P_DOCUMENT_TYPE_TO: this.Params.DOCUMENT_TYPE_TO,
        P_DOCUMENT_NO_FROM: this.Params.DOCUMENT_NO_FROM,
        P_DOCUMENT_NO_TO: this.Params.DOCUMENT_NO_TO,
        P_DOCUMENT_DATE_FROM: this.SetFormatDate(this.Params.DOCUMENT_DATE_FROM),
        P_DOCUMENT_DATE_TO: this.SetFormatDate(this.Params.DOCUMENT_DATE_TO)
      }
    );
  
  }

  SetFormatDate(date) {
    if (date) {
      let d = new Date(date);
      let day = d.getDate();
      let newDay = day.toString().length < 2 ? 0 + '' + day : day
      let year = d.getFullYear()
      let month = d.getMonth() + 1;
      let newMonth = month.toString().length < 2 ? 0 + '' + month : month
      return newDay + '-' + newMonth + '-' + year;
    }
}

}

