import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { MatPaginator } from '@angular/material/paginator';
import { MatSort } from '@angular/material/sort';
import { ModalService } from 'src/app/core/modal.service';
import { ActivatedRoute } from '@angular/router';
import { Globals } from 'src/app/core/global';
import * as moment from 'moment';

@Component({
  selector: 'SNPP021EX_M',
  templateUrl: './SNPP021EX_M.component.html',
  styleUrls: ['./SNPP021EX_M.component.css']
})

export class SNPP021EX_MComponent implements OnInit {

  @ContentChild(TemplateRef, { static: false }) templateRef;
  @ViewChild(MatPaginator, { static: true }) paginator: MatPaginator;
  @ViewChild(MatSort, { static: true }) sort: MatSort;

  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private route: ActivatedRoute,
    private global: Globals
  ) { 

  }

  public data: any = [];
  public poRange: any = {};
  public poDate: moment.Moment;

  ngOnInit() { }

  RunProcess() {

    this.modal.confirm("Do you want to run process?", this.viewref,
      () => {
        this.http.post("IC", "SNPP021EX_M_BeginProcess", {})
          .subscribe(result => {
            this.modal.info("Process Completed!", this.viewref)
            this.poDate = moment();
            this.poRange = result;
          }, (err) => {
            this.modal.error(err.error, this.viewref);
          })
      }, () => { }
    )
  }
  
  PrintReport() {
    this.global.GoToReport("PMS_RPT_IC_SNPP021", {
      P_PO_DATE: this.global.ConvertDateToFormatSTD(this.poDate),
      P_PO_NO_FROM: this.poRange.START_PO,
      P_PO_NO_TO: this.poRange.END_PO,
    })
  }

}
