import { Component, OnInit, ViewEncapsulation, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { FormGroup, FormControl, FormBuilder } from '@angular/forms'
import { Router } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';

@Component({
  selector: 'snm033p',
  templateUrl: './snm033p.component.html',
  styleUrls: ['./snm033p.component.css'],
  encapsulation: ViewEncapsulation.None
})



export class SNM033PComponent implements OnInit {
  options: FormGroup;
  constructor(
    private http: HttpService,
    private router: Router,
    private modal : ModalService,
    private viewref : ViewContainerRef
  ) { 


  }

  

  @ViewChild("dialogEdit",{static : false}) dialogEdit : any;
  @ViewChild("dialogAdd",{static : false}) dialogAdd : any;


  public CustomerList: any;
  private loaded: boolean = false;
  public tableData: any = [];
  public Update: any = [];
  public tableName: string;
  public show: boolean = true;
  public Location_No: string = '';
  public UpdateData : any = {}
  public AddData : any = {
    LOCATION_NO : null,
    PART_NO : null,
    DIMENSION_MAX : null,
    DIMENSION_MID : null,
    DIMENSION_MIN : null,
    RACK_CODE : null,
    RACK_GROUP_CODE : null,
    SEQUENCE_NO : null,
    PART_CATEGORY : null,
    LOCK_LOCATION : null,
    ATTRIBUTE2 : null,
  }

  public ConfigLocation: any = {
    ColName: "LOCATION_NO",
    ColValue: "LOCATION_NO",
    PlaceholderText: "Select Location",
    SourceController: "wPMS",
    SourceMethodName: "GetLocation",
    NoOfShowRecords: 30,
    MinLengthSearch: 3
  }


  public ConfigRackCode: any = {
    ColName: "RACK_CODE",
    ColValue: "RACK_CODE",
    PlaceholderText: "Select Rack Code",
    SourceController: "wPMS",
    SourceMethodName: "GetRackCode",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
  }

  public ConfigRackGroupCode: any = {
    ColName: "RACK_GROUP_CODE",
    ColValue: "RACK_GROUP_CODE",
    PlaceholderText: "Select Rack Group Code",
    SourceController: "wPMS",
    SourceMethodName: "GetRackGroupCode",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    SourceParams: {
      
    }
  }

  public ConfigReasonCode: any = {
    ColName: "LOOKUP_REASON",
    ColValue: "REASON_CODE",
    PlaceholderText: "Select Reason Code",
    SourceController: "wPMS",
    SourceMethodName: "GetReasonCode",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
  }

  public ConfigPart: any = {
    ColName: "LOOKUP_PART_NAME",
    ColValue: "PART_NO",
    PlaceholderText: "Select Part No",
    SourceController: "wPMS",
    SourceMethodName: "GetPartNo",
    NoOfShowRecords: 30,
    MinLengthSearch: 5,
  }

  public CategolyList = [1,2,3,4,5,6,7,8,9,10,11,12]

  ngOnInit() {


  }




  Search() {
    this.tableData = [];
    this.http.get('WH', 'SNM033P_GetData',  this.Location_No )
      .subscribe(res => {
        this.tableData = res.Table;
        console.log('res',res)
        this.Update = this.tableData.reduce((prev, current) => (prev.LAST_UPD_DATE > current.LAST_UPD_DATE) ? prev : current)
      })
  }



  EditRow(row) {
    this.UpdateData = row;
    this.dialogEdit.OpenDialog();
    console.log('UpdateData',this.UpdateData)
  }


  SaveAdd(){
    console.log(this.AddData);
    this.modal.confirm('Do you want to save changed you have made?', this.viewref, this.ConfirmSaveAdd)
  }


  ConfirmSaveAdd = () => {

    this.http.post('WH', 'SNM033P_InsertLocation', this.AddData)
        .subscribe(res => {

          console.log('res',res)
            if (res.Table[0].STATUS == 'DONE') {
                this.modal.info('Transaction complete 1 record applied and saved', this.viewref);
                this.dialogEdit.Close()
                this.Search();
            } else if  (res.Table[0].STATUS == 'DUPPLICATE') {
                this.modal.warning('No change to save. Found dupplicate record.', this.viewref);
            }else{
              this.modal.error('Transaction not complete 1 record not applied', this.viewref);
            }
        })
}

  SaveEdit() {

      this.modal.confirm('Do you want to save changed you have made?', this.viewref, this.ConfirmSaveEdit)
    
  }

  ConfirmSaveEdit = () => {

          this.http.post('WH', 'SNM033P_UpdateLocation', this.UpdateData)
              .subscribe(res => {
                  if (res.Table[0].STATUS == 'Done') {
                      this.modal.info(res.Table[0].MESSAGE, this.viewref);
                      this.dialogEdit.Close()
                      this.Search();
                  } else {
                      this.modal.info(res.Table[0].MESSAGE, this.viewref);
                  }
              })
  }

  CancelEdit(){
    this.dialogEdit.Close();
  }


  Delete(data){
   
    if(data.PART_NO){
      this.modal.warning('Can not delete part no error',this.viewref)
    }else{
      this.modal.confirm('Do you want to delete record?',this.viewref,() => this.ConfirmDelete(data))
    }
  }

  ConfirmDelete = data => {

    this.http.get('WH','SNM033P_Delete',data.LOCATION_NO)
    .subscribe(res => {
      if (res.Table[0].STATUS == 'Done') {
        this.modal.info('Delete completed!', this.viewref);
        this.dialogEdit.Close()
        this.Search();
    } else {
        this.modal.info('Delete not completed!', this.viewref);
    }
    })
  }
  
  CancelAdd() {
    this.dialogAdd.Close();
  }

}

