import { Component, OnInit, ViewChild, ViewContainerRef } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from '../../../core/modal.service';
import { Globals } from '../../../core/global';
import { ActivatedRoute } from '@angular/router';


@Component({
  selector: 'snse197',
  templateUrl: './SNSE197.component.html',
  styleUrls: ['./SNSE197.component.css']
})

export class SNSE197Component implements OnInit {
  private data: Array<any> = [];
  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private route: ActivatedRoute,
    private global: Globals
  ) {
  }


  public CustomerList: any;
  public tableData: any = [{}];
  public tableDataShowInfo: any = [{}];
  public tableData1: any = [{}];
  public SelectList: any = [];
  private files: any = [];
  public FileName: string = ""
  public totalUpload: number = 0;
  public totalError: number = 0;
  public DataUploadList: any;

  public params: any = {}


  @ViewChild("dialogInfo") dialogInfo: any
  @ViewChild("dialogInfo2") dialogInfo2: any

  ngOnInit() {

  }

  public ConfigPartNo: any = {
    ColName: "PART_NO",
    PlaceholderText: "Select Part No",
    SourceController: "TI",
    SourceMethodName: "SNSE197_getPartNo",
    NoOfShowRecords: 20,
    MinLengthSearch: 0,
    UpperCase: true
  }


  public SetPartNo(values: any, data: any) {
    this.params.CURR_NET_PRICE_1 = null;
    this.params.CURR_NET_PRICE_2 = null;
    this.params.CURR_EFFECTIVE_DATE = null;
    this.params.PART_NO = values.PART_NO;
    this.params.PART_NAME = values.PART_NAME;
    this.http.post('TI', 'SNSE197_All_Current', this.params)
      .subscribe(res => {
        this.params.CURR_NET_PRICE_1 = res.Table[0].CURR_NET_PRICE_1;
        this.params.CURR_NET_PRICE_2 = res.Table[0].CURR_NET_PRICE_2;
        this.params.CURR_EFFECTIVE_DATE = res.Table[0].CURR_EFFECTIVE_DATE;
      })
  }

  public Info() {
    this.dialogInfo.OpenDialog();
    this.http.post('TI', 'SNSE197_ShowInfo', this.params)
      .subscribe(res => {
          this.tableDataShowInfo = res.Table;
      })
  }

  public Info2() {
    this.dialogInfo2.OpenDialog();
  }

  public UpdateNetPrice() {
    this.modal.confirm("Do you want to update your change?", this.viewref,
      () => {
        this.http.post('TI', 'SNSE197_Update_Net_Price', this.params)
          .subscribe(res => {
            console.log(res)
            if (res.Table[0].STATUS === "DONE") {
              this.modal.info('Save successfully', this.viewref)
              this.params = {};
              this.dialogInfo.Close();
            }
          }, (err) => {
            console.log(err, 'err')
          })
      }, () => { })
  }
  
  public UpdateNetPrice1() {
    
  }

  OnFileSelect(fileInput) {
    this.files = fileInput.target.files;
    this.FileName = this.files[0].name;
  }

  public PreviewData() {
    if (this.files.length == 0) {
      this.modal.error('Please Open xlsx File First...', this.viewref)
    } else {
      this.data = []
      let formData = new FormData();
      formData.append('file', this.files[0]);

      this.http.postFile('TI', 'SNSE197_Upload_CSV', formData)
        .subscribe(res => {
          this.DataUploadList = null;
          this.http.get('SL', 'SNSQ01E_GetTempData')
            .subscribe(res => {
              this.DataUploadList = res.Table;
              if (this.DataUploadList.length > 0) {
                this.DataUploadList.forEach((e, index) => {
                  e.NO = index + 1;
                });
              }
            });
        });
    }
  }
}


