import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { MatTableDataSource } from '@angular/material/table';
import { MatPaginator } from '@angular/material/paginator';
import { MatSort } from '@angular/material/sort';


@Component({
  selector: 'snpe018',
  templateUrl: './snpe018.component.html',
  styleUrls: ['./snpe018.component.css']
})



export class SNPE018Component implements OnInit {

  @ContentChild(TemplateRef, { static: false }) templateRef;
  @ViewChild(MatPaginator, { static: true }) paginator: MatPaginator;
  @ViewChild(MatSort, { static: true }) sort: MatSort;

  constructor(
    private http: HttpService,
    private router: Router
  ) { }


  public headerList: any;
  public data: any;
  public dataList: any;
  public displayedColumns: string[]=[];
  public isCustomContent: boolean = false;
  public CustomerList: any = [];

  ngOnInit() {

    this.headerList = [{ FIELD_NAME: "SEQ", TITLE: "Seq" },
      { FIELD_NAME: "ACCEPTPARTNO", TITLE: "Accept PartNO." },
      { FIELD_NAME: "KIT", TITLE: "KIT" },
      { FIELD_NAME: "PONUMBER", TITLE: "P/O Number" },
      { FIELD_NAME: "QUANTITY", TITLE: "Quantity" },
      { FIELD_NAME: "UNITPRICE", TITLE: "Unit Prince" },
      { FIELD_NAME: "AMOUNT", TITLE: "Amount" },
      { FIELD_NAME: "ITEMNO", TITLE: "Item No." },
      { FIELD_NAME: "SUBItem", TITLE: "Sub Item" }];

    this.data = [{
      SEQ: '1',
      ACCEPTPARTNO: '1',
      KIT: '1',
      PONUMBER: '1',
      QUANTITY: '1',
      UNITPRICE: '1',
      AMOUNT: '1',
      ITEMNO: '1',
      SUBItem: '1',
    },
      {
        SEQ: '2',
        ACCEPTPARTNO: '2',
        KIT: '2',
        PONUMBER: '2',
        QUANTITY: '2',
        UNITPRICE: '2',
        AMOUNT: '2',
        ITEMNO: '2',
        SUBItem: '2',
      },
    {
      SEQ: '3',
      ACCEPTPARTNO: '3',
      KIT: '3',
      PONUMBER: '3',
      QUANTITY: '3',
      UNITPRICE: '3',
      AMOUNT: '3',
      ITEMNO: '3',
      SUBItem: '3',
      },
      {
        SEQ: '3',
        ACCEPTPARTNO: '3',
        KIT: '3',
        PONUMBER: '3',
        QUANTITY: '3',
        UNITPRICE: '3',
        AMOUNT: '3',
        ITEMNO: '3',
        SUBItem: '3',
      },
      {
        SEQ: '3',
        ACCEPTPARTNO: '3',
        KIT: '3',
        PONUMBER: '3',
        QUANTITY: '3',
        UNITPRICE: '3',
        AMOUNT: '3',
        ITEMNO: '3',
        SUBItem: '3',
      },
      {
        SEQ: '3',
        ACCEPTPARTNO: '3',
        KIT: '3',
        PONUMBER: '3',
        QUANTITY: '3',
        UNITPRICE: '3',
        AMOUNT: '3',
        ITEMNO: '3',
        SUBItem: '3',
      },
      {
        SEQ: '3',
        ACCEPTPARTNO: '3',
        KIT: '3',
        PONUMBER: '3',
        QUANTITY: '3',
        UNITPRICE: '3',
        AMOUNT: '3',
        ITEMNO: '3',
        SUBItem: '3',
      },
      {
        SEQ: '3',
        ACCEPTPARTNO: '3',
        KIT: '3',
        PONUMBER: '3',
        QUANTITY: '3',
        UNITPRICE: '3',
        AMOUNT: '3',
        ITEMNO: '3',
        SUBItem: '3',
      },
       {
        SEQ: '3',
        ACCEPTPARTNO: '3',
        KIT: '3',
        PONUMBER: '3',
        QUANTITY: '3',
        UNITPRICE: '3',
        AMOUNT: '3',
        ITEMNO: '3',
        SUBItem: '3',
      },
      {
        SEQ: '3',
        ACCEPTPARTNO: '3',
        KIT: '3',
        PONUMBER: '3',
        QUANTITY: '3',
        UNITPRICE: '3',
        AMOUNT: '3',
        ITEMNO: '3',
        SUBItem: '3',
      }
    ]

    this.dataList = new MatTableDataSource<any>(this.data);
    this.displayedColumns = this.headerList.map(v => v.FIELD_NAME);

  }

 
  ngAfterContentInit(): void {
    if (this.templateRef) {
      this.isCustomContent = true;
    }
  }

}
