import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
//import { Router } from '@angular/router';
//import { Globals } from 'src/app/core/global';
//import { FormControl, Validators } from '@angular/forms';
import { ModalService } from 'src/app/core/modal.service';
import { SelectionModel } from '@angular/cdk/collections';


@Component({
  selector: 'SNSE038',
  templateUrl: './SNSE038.component.html',
  styleUrls: ['./SNSE038.component.css']
})



export class SNSE038Component implements OnInit {

  constructor(
    private http: HttpService,
    //private router: Router,
    //private global: Globals,
    private modal: ModalService,
    private viewRef: ViewContainerRef
  ) { }

  public params:any = {}

  public tableData: any;


  public DataIsSelected: any;
  public selection = new SelectionModel<any>(true, []);


  public tblFooter: any = [
    {
      fieldName: "PART_NO",
      value: "Total",
      show: true
    },
    {
      fieldName: "ACCEPT_QTY",
      
      show: true
    },
    {
      fieldName: "NET_AMT_B",
      
      show: true
    }

  ]


  ngOnInit() {
    this.params.PICK_LOT_DATE = new Date();
  }

  public lookupCustomerCodeConfig: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    PlaceholderText: "Select Customer Code",
    SourceController: "SL",
    SourceMethodName: "SNSE038_GetCustomerCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetSelectedCustomerCode(values: any) {
    this.params.CUSTOMER_CODE = values.CUSTOMER_CODE;
    this.params.CUSTOMER_NAME = values.CUSTOMER_NAME;
    this.params.ORDER_NO = null;
    this.params.ORDER_CLASS = null;
    this.params.ORDER_DATE = null;
    this.params.BO_FLAG = null;
    this.params.LOCK_CUSTOMER = null;
    this.params.LAST_UPD_DATE = null;
    this.params.LAST_UPD_NAME = null;
  }

  public lookupOrderNoConfig: any = {
    ColName: "ORDER_NO_TEXT",
    PlaceholderText: "Select Order No",
    SourceController: "SL",
    SourceMethodName: "SNSE038_GetOrderNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params
    },
    UpperCase: true
  }

  public SetSelectedOrderNo(values: any) {
    this.params.ORDER_NO = values.ORDER_NO;
    //this.params.ORDER_CLASS = values.ORDER_CLASS;
    //this.params.DSP_ORDER_CLASS = values.DSP_ORDER_CLASS;
    //this.params.ORDER_DATE = values.ORDER_DATE;
    //this.params.BO_FLAG = values.BO_FLAG;
    //this.params.LOCK_CUSTOMER = values.LOCK_CUSTOMER;
    //this.params.LAST_UPD_DATE = values.LAST_UPD_DATE;
    //this.params.LAST_UPD_NAME = values.LAST_UPD_NAME;

   // this.Search();
  }
  CheckBox(event, data) {

    //this.selectCase.TotolCase = 0;
    //this.selectCase.TotolSelect = 0;

    //this.dataSelected = this.tableData.filter(v => v.CHK_BOX === true);

    //this.dataSelected.forEach((value) => {

    //  this.selectCase.TotolCase = this.selectCase.TotolCase + 1;
    //  this.selectCase.TotolSelect = this.selectCase.TotolSelect + value.PACK_QTY;


    //});

    //this.selectCase5.TotolCase = 0;
    //this.selectCase5.TotolSelect = 0;

    //this.dataSelected5 = this.tableData.filter(v => v.CHK_BOX === true);

    //this.dataSelected5.forEach((value) => {

    //  this.selectCase5.TotolCase = this.selectCase5.TotolCase + 1;
    //  this.selectCase5.TotolSelect = this.selectCase5.TotolSelect + value.PACK_QTY;


    //});

  }

  public SetSelectedOrderNoTo(values: any) {
    this.params.ORDER_NO_TO = values.ORDER_NO;
    //this.params.ORDER_CLASS = values.ORDER_CLASS;
    //this.params.DSP_ORDER_CLASS = values.DSP_ORDER_CLASS;
    //this.params.ORDER_DATE = values.ORDER_DATE;
    //this.params.BO_FLAG = values.BO_FLAG;
    //this.params.LOCK_CUSTOMER = values.LOCK_CUSTOMER;
    //this.params.LAST_UPD_DATE = values.LAST_UPD_DATE;
    //this.params.LAST_UPD_NAME = values.LAST_UPD_NAME;

  //  this.Search();
  }

  public Search = () => {
    this.tableData = null;
    this.http.post('SL', 'SNSE038_GetData', this.params)
      .subscribe(res => {
        this.tableData = res.Table;

        if (this.tableData) {
          this.params.ROW_FROM = 1;
          this.params.ROW_TO = this.tableData.length;

          for (var i = 0; i < this.tableData.length; i++) {
            this.tableData[i].CHK_BOX = true;
          
          }
        }
       
      })
  }

  isAllSelected() {
    const numSelected = this.selection.selected.length;
    const numRows = this.tableData.length;
    return numSelected === numRows;
  }

  Toggle() {
    if (this.isAllSelected()) {
      this.selection.clear()
      this.tableData.map(x => {
        this.DataIsSelected = [];
      })
    } else {
      this.tableData.forEach(row => this.selection.select(row));
      this.DataIsSelected = [];
      this.tableData.map(x => {
        this.DataIsSelected.push(x);
      })
    }
  }

  CheckboxChange(event, data) {
    if (event.checked) {
      this.DataIsSelected.push(data);
    }
    else {
      this.DataIsSelected.splice(this.DataIsSelected.indexOf(data), 1);
    }
  }

  Retrieve_Click() {

    this.http.post('SL', 'SNSE015_AllocateOrder', this.params)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info("Allowcate Order Completed.", this.viewRef);
          this.Search();


        }
        else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewRef);
        }
      })
  }

  public SelectRow() {

    for (var i = 0; i < this.tableData.length; i++) {
      if (this.params.ROW_FROM <= i+1 && this.params.ROW_TO >= i+1) {
        this.tableData[i].CHK_BOX = true;
      } else {
        this.tableData[i].CHK_BOX = false;
      }
    }

  }

  public SelectAll() {
   
    this.tableData.forEach((value) => {
      value.CHK_BOX = true;
    });

  }

  public Process() {

    var dataSelected = this.tableData.filter(v => v.CHK_BOX == true);
    console.log('dataSelected ', dataSelected);
    console.log('dataSelected.length ', dataSelected.length);
    if (dataSelected.length > 0) {

      dataSelected[0].PICK_LOT_DATE = this.params.PICK_LOT_DATE;
      this.http.post('SL', 'SNSE038_Process', dataSelected)
        .subscribe(result => {
          if (result.substring(0, 4) == "DONE") {
            this.Search();
            this.params.SEQ = result.substring(5, 20);
            this.modal.info("Confirm successfully " + result.substring(5, 20), this.viewRef);
          } else {

            this.modal.warning("Found an error, please contract support team", this.viewRef);
          }
        }, (err) => {

          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        })

    } else {
      this.modal.warning("No data selected!!!", this.viewRef);
    }



  }

}
