
import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef, Inject, SimpleChanges, OnChanges } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { FormControl } from '@angular/forms';
import * as moment from 'moment';

import { ModalService } from 'src/app/core/modal.service';
import { MatDialog, MatDialogRef, MAT_DIALOG_DATA } from '@angular/material/dialog';

@Component({
  selector: 'SNSQ005_OnOrder',
  templateUrl: './SNSQ005_OnOrder.component.html',
  styleUrls: ['./../SNSQ005_001.component.css']
})

export class SNSQ005_OnOrderComponent implements OnChanges{

  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    public dialog: MatDialog,
    private viewRef: ViewContainerRef
  ) { }


  @Input() pPartNo: string;
  @Input() pCurrencyCode: string;


  public dataAir: any = [];
  public dataSea: any = [];
  public dataLocal: any = [];

  public dataList: any = [];

  public dataOnOrder: any = {};

  public dataDetail: any = [];
  public vendorETD: any = [];

  public findPO: any;
  public CustomerList: any;
  public tableData: any;
  public filter: any = [];


  ngOnInit() {
    this.GetData();
  }


  ngOnChanges(changes: SimpleChanges): void {

    if (!changes["pPartNo"].isFirstChange()) {
      this.GetData();
    }
  }
  
  public ZeroToBank(pValue) {
    if (pValue == 0) {
      return '';
    }
    return pValue;
  }
  private GetData() {
    if (this.pPartNo.length >= 3) {
      this.http.get("IC", "SNSQ005_GetIndentInfo", this.pPartNo)
        .subscribe(result => {
          this.dataAir = result.Table[0];
          this.dataSea = result.Table1[0];
          this.dataLocal = result.Table2[0];
          this.dataDetail = result.Table3;
        })       

    } else {

    }

  }


  public ViewVendorETD(row) {
    
    this.vendorETD = [];

    this.http.get("IC", "SNSQ005_GetVendorETD", row.PO_NO, row.ITEM_NO)
      .subscribe(result => {
        this.vendorETD = result.Table;
      })

  }
}
