import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from '../../../core/modal.service';
import { Moment } from 'moment';


@Component({
  selector: 'snsq026_001',
  templateUrl: './SNSQ026_001.component.html',
  styleUrls: ['./SNSQ026_001.component.css']
})



export class SNSQ026_001Component implements OnInit {


  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef,
  ) {
  }
  public tabledata: any = [];
  public PROCESS_LOG: any = [];



  public params = {
    VENDOR_CODE: null,
    PART_NO: null,
    PART_NAME: null,
    CUSTOMER_CODE: null,
    CUSTOMER_CODE_E: null,
    CUSTOMER_NAME: null
  }


  ngOnInit() {

  }

  public configVendorCode: any = {
    ColName: "LOOKUP_VENDOR",
    PlaceholderText: "VENDOR CODE",
    SourceController: "SL",
    SourceMethodName: "SNSQ026_001_getVendorCode",
    NoOfShowRecords: 20,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public configPartNo: any = {
    ColName: "LOOKUP_PARTNUMBER",
    PlaceholderText: "ORDER PART NO",
    SourceController: "SL",
    SourceMethodName: "SNSQ026_001_getPartNo",
    NoOfShowRecords: 20,
    MinLengthSearch: 0,
    UpperCase: true,
    SourceParams: {
      DATA: this.params
    },
  }

  public configCustomerCode: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    PlaceholderText: "CUSTOMER CODE",
    SourceController: "SL",
    SourceMethodName: "SNSQ026_getCustomerCode",
    NoOfShowRecords: 20,
    MinLengthSearch: 0,
    UpperCase: true,
    SourceParams: {
      DATA: this.params
    },
  }

  public Search() {
    this.tabledata = [];
    this.http.post("SL", "SNSQ026_001_getSearch", this.params)
      .subscribe(res => {
        this.tabledata = res.Table;
      })
  }

  public ExportExcel() {
    this.http.Download("SL", "SNSQ026_001_Export_Excel", JSON.stringify(this.tabledata))
      .subscribe(res => {
        if (res) {
          this.WriteContents(res)
          this.PROCESS_LOG.push('Export complete ' + this.tabledata.length + ' records.');
        } else {
          this.modal.error('Download not complete', this.viewref)
        }
      })
  }

  public WriteContents(content) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    var date_export = new Date();
    a.href = URL.createObjectURL(file);
    a.download = "SNSQ026" + "_" + date_export.getFullYear() + "/" + (date_export.getMonth() + 1) + "/" + date_export.getDate() + ".csv";
    a.click();
  }



  public SetLookupVendor(values: any) {
    this.params.VENDOR_CODE = values.VENDOR_CODE;
  }

  public SetPartNo(values: any) {
    this.params.PART_NO = values.ORDER_PART_NO;
    this.params.PART_NAME = values.PART_NAME_EN;
  }


  public SetCustomerCode(values: any) {
    this.params.CUSTOMER_CODE = values.CUSTOMER_CODE;
    this.params.CUSTOMER_NAME = values.CUST_NAME_EN;
  }
  
}

