import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { MatTableDataSource } from '@angular/material/table';
import { retry } from 'rxjs/operators';
import { __await } from 'tslib';
import { FormControl } from '@angular/forms';
import { ModalService } from 'src/app/core/modal.service';
import { MatPaginator } from '@angular/material/paginator';
import { Globals } from 'src/app/core/global';



@Component({
    selector: 'snsq027_001',
    templateUrl: './SNSQ027_001.component.html',
    styleUrls: ['./SNSQ027_001.component.css']
})

export class SNSQ027_001Component {

    constructor(
        private HttpService: HttpService,
        private router: Router,
        private modal: ModalService,
        private viewref: ViewContainerRef,
        private global: Globals
    ) { }


    public tableData: any;
    public PartNo_Text: string = "";
    public SALE_TYPE_List: any = [];
    public Customer_Text: string = "";
    public OrderClassList: any = [];
    public orderClass: any;
    public formData: any = {AGED_BO: "30"};
    @ViewChild(MatPaginator, { static: true }) paginator: MatPaginator;
    private origin: string = window.location.protocol + "//" + window.location.hostname + ":8090";


    public VendorCode: any;
    public PartNo: any
    public CustomerCode: any;
    public OrderNo: any;
    public StaffUser: any;
    public dataList: any;
    public dataList2: any;
    public Part_No: any = '';
    public Order_Class: any = '';
    public CounterItem: number = 0;
    public CounterItem2: number = 0;
    public lookupConfigVendor: any = {
        ColName: "VENDOR_TEXT",
        ColValue: "VENDOR_CODE",
        PlaceholderText: "Select Vendor",
        SourceController: "IC",
        SourceMethodName: "SNSQ027_GetVendor",
        NoOfShowRecords: 50,
        MinLengthSearch: 1,
        UpperCase: true
    }

    public lookupConfigPartNo: any = {
        ColName: "ORDER_PART_TEXT",
        PlaceholderText: "Select Part No.",
        SourceController: "IC",
        SourceMethodName: "SNSQ027_GetPartNo",
        NoOfShowRecords: 50,
        MinLengthSearch: 2,
        UpperCase: true
    }

    public lookupConfigCustomer: any = {
        ColName: "CUSTOMER_TEXT",
        // ColValue: "CUSTOMER_CODE",
        PlaceholderText: "Select Customer Code.",
        SourceController: "IC",
        SourceMethodName: "SNSQ027_GetCustomer",
        NoOfShowRecords: 50,
        MinLengthSearch: 3,
        UpperCase: true
    }

    public lookupConfigOrder: any = {
        ColName: "ORDER_TEXT",
        ColValue: "ORDER_NO",
        PlaceholderText: "Select Order No.",
        SourceController: "IC",
        SourceMethodName: "SNSQ027_GetOrder",
        NoOfShowRecords: 50,
        MinLengthSearch: 3,
        UpperCase: true
    }

    public lookupConfigStaff: any = {
        ColName: "ORDER_TEXT",
        ColValue: "SK_USER_ID",
        PlaceholderText: "Select Staff Inchange",
        SourceController: "IC",
        SourceMethodName: "SNSQ027_GetStaffUser",
        NoOfShowRecords: 50,
        MinLengthSearch: 0,
        UpperCase: true
    }
    public tblFooter: any = [
        {
            fieldName: "V_ITEM_NO",
            value: "Sum QTY.",
            show: true
        },
        {
            fieldName: "ACCEPT_QTY",
            show: true
        }
    ]
    public tblFooter1: any = [
        {
            fieldName: "V_AGED",
            value: "Sum QTY.",
            show: true
        },
        {
            fieldName: "ACCEPT_QTY",
            show: true
        }
    ]

    ngOnInit() {

        this.SALE_TYPE_List = [{ ID: 'D', TEXT: "Domestic" }, { ID: 'E', TEXT: "Export" }]
        this.GetOrderClass()
    }

    GetSearchBO() {
        this.dataList = [];
        let formData: any = {};
        formData.VendorCode = this.formData.VendorCode || '';
        formData.PartNo = this.formData.PartNo || '';
        formData.AGED_BO = this.formData.AGED_BO || '';
        formData.CustomerCode = this.formData.CustomerCode || '';
        formData.OVERSEA_FLAG_C = this.formData.OVERSEA_FLAG_C || '';
        formData.OrderNo = this.formData.OrderNo || '';
        formData.ORDER_CLASS = (this.orderClass || []).join(",");
        formData.StaffUser = this.formData.StaffUser || '';

        this.HttpService.post("IC", "SNSQ027_GetDataList", JSON.stringify(formData))
            .subscribe(result => {
                this.dataList = result.Table;
                this.CounterItem = this.dataList.length;
            })
    }

    GetBoList(row) {
        this.dataList2 = [];
        this.Part_No = row.ORDER_PART_NO
        this.Order_Class = row.ORDER_CLASS
        this.HttpService.post('IC', 'SNSQ027_GetBo_By_PartNo', JSON.stringify(row))
            .subscribe((result: any) => {
                this.dataList2 = result.Table;
                this.CounterItem2 = this.dataList2.length;
            })
    }


    SetVendorCodeLookup(v) {
        this.formData.VendorCode = v;
    }

    SetPartNoCodeLookup(p) {
        this.formData.PartNo = p.ORDER_PART_NO;
        this.PartNo_Text = p.PART_NAME_EN;
    }

    SetCustomerCodeLookup(c) {
        this.formData.CustomerCode = c.CUSTOMER_CODE;
        this.Customer_Text = c.CUST_NAME_EN;
    }

    SetOrderLookup(o) {
        this.formData.OrderNo = o;
    }

    SetStaffUserLookup(s) {
        this.formData.StaffUser = s;
    }

    GetOrderClass() {
        this.HttpService.get("IC", "SNSQ027_GetOrderClass")
            .subscribe((result: any) => {
                this.OrderClassList = result.Table;
            })
    }


    ExportOnScreen() {

        this.global.GoToExport("PMS_RPT_IC_SNSQ027_OnScreen",
            {
                P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
                P_VENDOR_CODE: this.formData.VendorCode || null,
                P_PART_NO: this.formData.PartNo || null,
                P_AGED_BO: this.formData.AGED_BO || null,
                P_CUSTOMER_CODE: this.formData.CustomerCode || null,
                P_OVERSEA_FLAG_C: this.formData.OVERSEA_FLAG_C || null,
                P_ORDER_NO: this.formData.OrderNo || null,
                P_ORDER_CLASS: (this.orderClass && this.orderClass.length > 0) ? this.orderClass.join(",") : null,
                P_STAFF_INCHANGE: this.formData.StaffUser || null,
            }, true, "EXCELOPENXML")
    }

    ExportETD() {

        this.global.GoToExport("PMS_RPT_IC_SNSQ027_ETDInfo",
            {
                P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
                P_PART_NO: this.Part_No || null,
                P_ORDER_CLASS: this.Order_Class || null
            }, true, "EXCELOPENXML")
    }


    download(content) {

        const a = document.createElement('a');
        const file = new Blob([content], { type: content.type })
        a.href = URL.createObjectURL(file);
        a.download = "SNSQ027_OnScreen.csv"
        a.click()
    }

    download_ETD(content) {

        const a = document.createElement('a');
        const file = new Blob([content], { type: content.type })
        a.href = URL.createObjectURL(file);
        a.download = "SNSQ027_ETD.csv"
        a.click()
    }

}
