import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';

@Component({
  selector: 'snsq045_001',
  templateUrl: './SNSQ045_001.component.html',
  styleUrls: ['./SNSQ045_001.component.css']
})

export class SNSQ045_001Component implements OnInit {

  public params = {
    BUYER_CODE: null,
    FROM_DATE: null,
    TO_DATE: null,
    GROUP: 0
  }

  public tableData: any = [];
  public TOTAL_RECORD: any = 0;

  constructor(
    private Http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) { }

  ngOnInit() {
    var date = new Date();
    this.params.FROM_DATE = new Date(date.getFullYear(), date.getMonth(), 2);
    this.params.TO_DATE = new Date();
  }

  public lookupBuyerCodeConfig: any = {
    ColName: "LOOKUP_BUYER_CODE",
    PlaceholderText: "Select Buyer Code",
    SourceController: "SL",
    SourceMethodName: "SNSQ045_getBuyerCode",
    NoOfShowRecords: 100,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetSelectedBuyerCode(value: any) {
    this.params.BUYER_CODE = value.BUYER_CODE;
  }

  Search() {
    this.tableData = [];
    this.TOTAL_RECORD = 0;
    this.Http.post("SL", "SNSQ045_getData", this.params)
      .subscribe(res => {
        this.tableData = res.Table;
        this.TOTAL_RECORD = this.tableData.length;
      })
  }

  ExportExcel() {
    this.Http.Download('SL', 'SNSQ045_getData_Export', JSON.stringify(this.params))
      .subscribe(res => {
        if (res) {
          this.WriteContents(res)
        } else {
          this.modal.error('Download not complete', this.viewref)
        }
      })
  }

  WriteContents(content) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    a.href = URL.createObjectURL(file);
    a.download = "SNSQ045.csv";
    a.click();
  }
}
