import { Component, OnInit, ViewContainerRef, ViewChild } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from '../../../core/modal.service';
import { error } from '@angular/compiler/src/util';


@Component({
    selector: 'snse182',
    templateUrl: './SNSE182.component.html',
    styleUrls: ['./SNSE182.component.css']
})

export class SNSE182Component implements OnInit {

    constructor(
        private HttpService: HttpService,
        private modal: ModalService,
        private viewref: ViewContainerRef
    ) { }

    private origin: string = window.location.protocol + "//" + window.location.hostname + ":8090";
    public tableData: any;
    public tableData2: any;
    public formData: any = { FROM_LOCATION_NO: '', TO_LOCATION_NO: '', FROM_NEW_LOCATION: '', TO_NEW_LOCATION: '', FROM_PARTS_NO: '', TO_PARTS_NO: '', FROM_PRINT_CODE: '', TO_PRINT_CODE: '', STATUS_CODE: '', UPD_FLAG: '' }
    public dataList: any;
    public StatusList: any = [];
    public UpdateFlagList: any = [];
    public CounterItem: number = 0;
    public CounterItem2: number = 0;
    public Part_No: any = '';
    public Print_Code: any = '';
    public dataRelocationLog: any;

    public lookupConfigCurrentLoca: any = {
        ColName: "CURRENT_LOCATION",
        ColValue: "LOCATION_NO",
        PlaceholderText: "Select Current Location",
        SourceController: "WH",
        SourceMethodName: "SNSE182_Current_Loca_Find",
        NoOfShowRecords: 50,
        MinLengthSearch: 2
    }

    public lookupConfigPartsNo: any = {
        ColName: "PART_NO",
        ColValue: "PARTS_NO",
        PlaceholderText: "Select Parts No",
        SourceController: "WH",
        SourceMethodName: "SNSE182_Parts_No_Find",
        NoOfShowRecords: 50,
        MinLengthSearch: 2
    }

    public lookupConfigNewLocation: any = {
        ColName: "NEW_LOCA",
        ColValue: "NEW_LOCATION",
        PlaceholderText: "Select New Location",
        SourceController: "WH",
        SourceMethodName: "SNSE182_New_Location_Find",
        NoOfShowRecords: 50,
        MinLengthSearch: 2
    }

    public lookupConfigPrintDate: any = {
        ColName: "PRINT_DATE",
        ColValue: "PRINT_CODE",
        PlaceholderText: "Select Print Date",
        SourceController: "WH",
        SourceMethodName: "SNSE182_PrintDate_Find",
        NoOfShowRecords: 50,
        MinLengthSearch: 2
    }

    @ViewChild("dialogPartLog") dialogPartLog: any;
    public selectedUpdateLocation: Array<any> = [];


    ngOnInit() {
        this.StatusList = [
            { ID: '1', TEXT: "1 = Print Relocation Crad" },
            { ID: '2', TEXT: "2 = Pick/Pack" },
            { ID: '3', TEXT: "3 = Shelve" },
            { ID: '4', TEXT: "4 = Relocation Complete" },
        ]
        this.UpdateFlagList = [{ ID: 'Y', TEXT: "Y = Updated New Location" }, { ID: 'N', TEXT: "N = Not Updated New Location" }]
    }

    SetFromCurrentLocaLookup(FromCurrent) {
        this.formData.FROM_LOCATION_NO = FromCurrent;
    }
    SetToCurrentLocaLookup(ToCurrent) {
        this.formData.TO_LOCATION_NO = ToCurrent;
    }
    SetFromPartsNoLookup(FromPartsNo) {
        this.formData.FROM_PARTS_NO = FromPartsNo;
    }
    SetToPartsNoLookup(ToPartsNo) {
        this.formData.TO_PARTS_NO = ToPartsNo;
    }
    SetFromNewLocationLookup(FromNewLocation) {
        this.formData.FROM_NEW_LOCATION = FromNewLocation;
    }
    SetToNewLocationLookup(ToNewLocation) {
        this.formData.TO_NEW_LOCATION = ToNewLocation;
    }
    SetFromPrintDateLookup(FromPrintDate) {
        this.formData.FROM_PRINT_CODE = FromPrintDate;
    }
    SetToPrintDateLookup(ToPrintDate) {
        this.formData.TO_PRINT_CODE = ToPrintDate;
    }

    GetSearchRelocationParts() {
        this.dataList = [];
        this.HttpService.get("WH", "SNSE182_GetRelocationParts",
            this.formData.FROM_LOCATION_NO || "null",
            this.formData.TO_LOCATION_NO || "null",
            this.formData.FROM_PARTS_NO || "null",
            this.formData.TO_PARTS_NO || "null",
            this.formData.FROM_NEW_LOCATION || "null",
            this.formData.TO_NEW_LOCATION || "null",
            this.formData.FROM_PRINT_CODE || "null",
            this.formData.TO_PRINT_CODE || "null",
            this.formData.STATUS_CODE || "null",
            this.formData.UPD_FLAG || "null"
        ).subscribe(result => {
            this.dataList = result.Table;
            this.CounterItem = this.dataList.length;
        }, (err) => { console.log(err) })

    }

    GetRelocationLog(row) {
        console.log(row, 'row')
        this.Part_No = row.PARTS_NO
        this.Print_Code = row.PRINT_CODE
        this.HttpService.post('WH', 'SNSE182_GetRelocationLog', JSON.stringify(row))
            .subscribe((result: any) => {
                this.dataRelocationLog = result.Table;
                this.CounterItem2 = this.dataRelocationLog.length;
                // console.log(result, 'this.dataList2')
                this.dialogPartLog.OpenDialog();
            })
    }

    ConfirmUpdateLocation() {
        this.HttpService.post("WH", "SNSE182_ConfirmUpdateLocation", this.selectedUpdateLocation)
            .subscribe(result => {
                this.modal.info("Confirm update new location succeed.", this.viewref);
            }, err => {
                console.error(err);
            })
    }

    RelocationParts_Export() {

        this.HttpService.Download("WH", "SNSE182_GetRelocationParts_Export", JSON.stringify(this.formData))
            .subscribe(result => {
                console.log('result', result);
                if (result) {

                    this.download(result)
                }
            }, (err) => {
                console.log(err, 'err')
            })

    }

    RelocationLog_Export() {
        this.HttpService.Download("WH", "SNSE182_GetRelocationLog_Export", { PartNO: this.Part_No, PrintCode: this.Print_Code })
            .subscribe(result => {
                console.log('result', result);
                if (result) {

                    this.download_Log(result)
                }
            }, (err) => {
                console.log(err, 'err')
            })

    }

    download(content) {

        const a = document.createElement('a');
        const file = new Blob([content], { type: content.type })
        a.href = URL.createObjectURL(file);
        a.download = "SNSE182_Relocation_Parts.csv"
        a.click()
    }

    download_Log(content) {

        const a = document.createElement('a');
        const file = new Blob([content], { type: content.type })
        a.href = URL.createObjectURL(file);
        a.download = "SNSE182_Relocation_Log.csv"
        a.click()
    }

    ToggleUpdateLocation(event, data) {
        if (event.checked) {
            this.selectedUpdateLocation.push({
                PRINT_CODE: data.PRINT_CODE,
                PARTS_NO: data.PARTS_NO,
                NEW_LOCATION: data.NEW_LOCATION,
                UPD_FLAG: data.UPD_FLAG
            })
        } else {
            let checkIndex = this.selectedUpdateLocation.findIndex(v => v.PRINT_CODE === data.PRINT_CODE && v.PARTS_NO === data.PARTS_NO);

            this.selectedUpdateLocation.splice(checkIndex, 1);
        }
    }

}

