import { Component, OnInit, ViewChild } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';

@Component({
  selector: 'snse187',
  templateUrl: './snse187.component.html',
  styleUrls: ['./snse187.component.css']
})

export class SNSE187Component implements OnInit {
  constructor(
    private http: HttpService,
    private router: Router,
    private global: Globals
  ) { }
  @ViewChild("dialogLoc", { static: false }) dialogLoc: any;
  @ViewChild("dialogPrint", { static: false }) dialogPrint: any;
  @ViewChild("dialogPart", { static: false }) dialogPart: any;

  public data: any;
  public tableSLoc: any;
  public tableSPart: any;
  public tableSPrit: any;
  public grdLoc: any;
  public grdPart: any;
  public grdPrint: any;
  public ReccordCount: any = 0;
  public params = {
    locationFrom: null,
    locationTo: null,
    PrintFrom: null,
    PartFrom: null,
    PartTo: null,
    PRINT_NO: null,
    PrintTo: null
  }
  public ConfigLocation: any = {
    ColName: "LOCATION_NO",
    ColValue: "LOCATION_NO",
    PlaceholderText: "Select Location",
    SourceController: "WH",
    SourceMethodName: "SNSE187_GetLocation",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: false
  }
  public ConfigPart: any = {
    ColName: "PART_NO",
    ColValue: "PART_NO",
    PlaceholderText: "Select Part",
    SourceController: "WH",
    SourceMethodName: "SNSE187_GetPart",
    NoOfShowRecords: 30,
    locationFrom: this.params.locationFrom !== null ? this.params.locationFrom:"null",
    locationTo: this.params.locationTo !== null ? this.params.locationTo:"null",
    MinLengthSearch: 1,
    UpperCase: false
  }
  public ConfigPrint: any = {
    ColName: "PRINT_NO",
    ColValue: "PRINT_NO",
    PlaceholderText: "Select Print",
    SourceController: "WH",
    SourceMethodName: "SNSE187_GetPrint",
    locationFrom: this.params.locationFrom !== null ? this.params.locationFrom:"null",
    locationTo: this.params.locationTo !== null ? this.params.locationTo:"null",
    PartFrom: this.params.PartFrom !== null ? this.params.PartFrom:"null",
    PartTo: this.params.PartTo !== null ? this.params.PartTo:"null",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: false
  }

  GetLocation(code, p) {
    if (p === "F") {
      this.params.locationFrom = code;
    }
    if (p === "T") {
      this.params.locationTo = code;
    }
  }
  GetPrint(code, p) {
    if (p === "F") {
      this.params.PrintFrom = code;
    }
    if (p === "T") {
      this.params.PrintTo = code;
    }
  }
  GetPart(code, p) {
    if (p === "F") {
      this.params.PartFrom = code;
    }
    if (p === "T") {
      this.params.PartTo = code;
    }
  }
  SearchLocation(p) {
    this.grdLoc = p;
    this.http.get("WH", "SNSE187_GetLocation")
      .subscribe(result => {
        if (result.Table.length > 0) {
          this.tableSLoc = result.Table;
        }
        this.dialogLoc.title = "Search Location No";
        this.dialogLoc.OpenDialog();
      });
  }
  SearchPart(p) {
    this.grdPart = p;
    this.http.get("WH", "SNSE187_GetPart", this.params.locationFrom !== null ? this.params.locationFrom : "null", this.params.locationTo !== null ? this.params.locationTo:"null")
      .subscribe(result => {
        if (result.Table.length > 0) {
          this.tableSPart = result.Table;
        }
        this.dialogPart.title = "Search Part No";
        this.dialogPart.OpenDialog();
      });
  }
  SearchPrint(p) {
    this.grdPrint= p;
    this.http.get("WH", "SNSE187_GetPrint", this.params.locationFrom !== null ? this.params.locationFrom: "null", this.params.locationTo !== null ? this.params.locationTo : "null", this.params.PartFrom !== null ? this.params.PartFrom : "null", this.params.PartTo !== null ? this.params.PartTo:"null")
      .subscribe(result => {
        if (result.Table.length > 0) {
          this.tableSPrit = result.Table;
        }
        this.dialogPrint.title = "Search Print No"
        this.dialogPrint.OpenDialog();
      });
  }
  GrdSelectLocation(evt) {
    if (this.grdLoc ==="F") {
      this.params.locationFrom = evt.LOCATION_NO;
    }
    if (this.grdLoc === "T") {
      this.params.locationTo = evt.LOCATION_NO;
    }
    this.dialogLoc.Close();
  }
  GrdSelectPart(evt) {
    if (this.grdPart === "F") {
      this.params.PartFrom = evt.PART_NO;
    }
    if (this.grdPart === "T") {
      this.params.PartTo = evt.PART_NO;
    }
    this.dialogPart.Close();
  }
  GrdSelectPrint(evt) {
    if (this.grdPrint === "F") {
      this.params.PrintFrom = evt.PRINT_NO;
    }
    if (this.grdPrint === "T") {
      this.params.PrintTo = evt.PRINT_NO;
    }
    this.dialogPrint.Close();
  }
  FindGrdData() {
    this.http.get("WH", "SNSE187_Search", this.params.locationFrom !== null ? this.params.locationFrom : "null", this.params.locationTo !== null ? this.params.locationTo : "null", this.params.PartFrom !== null ? this.params.PartFrom : "null", this.params.PartTo !== null ? this.params.PartTo : "null", this.params.PrintFrom !== null ? this.params.PrintFrom : "null", this.params.PrintTo !== null ? this.params.PrintTo:"null")
      .subscribe(result => {
        if (result.Table.length > 0) {
          this.data = result.Table;
          this.ReccordCount = result.Table.length;
        } else {
          this.ReccordCount = 0;
        }
      });
  }

  PrintReloCard() {
    this.global.GoToReport("PMS_RPT_WH_SNSR185",
      {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_LOCATION_FROM: this.params.locationFrom,
        P_LOCATION_TO: this.params.locationTo,
        P_PART_NO_FROM: this.params.PartFrom,
        P_PART_NO_TO: this.params.PartTo,
        P_PRINT_FROM: this.params.PrintFrom,
        P_PRINT_TO: this.params.PrintTo
      });

  }

  ngOnInit() {


  }
}
