import { Component, OnInit, ViewChild } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';

@Component({
  selector: 'snse193',
  templateUrl: './snse193.component.html',
  styleUrls: ['./snse193.component.css']
})

export class SNSE193Component implements OnInit {
  constructor(
    private http: HttpService,
    private router: Router,
    private global: Globals
  ) { }
  @ViewChild("dialog", { static: false }) dialog: any;
  public data: any;
  public StaffTypeList: any;
  public StaffList: any;
  public RowCount: any = 0;
  public params = {
    STAFF_ID: null,
    STAFF_NAME:null
  }
  public ConfigStaff: any = {
    ColName: "STAFF_ID",
    ColValue: "STAFF_ID",
    PlaceholderText: "Select Staff",
    SourceController: "WH",
    SourceMethodName: "SNSE193_GetStaffList",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: false
  }
  ngOnInit() {
    this.StaffTypeList = [
      {
        TYPE_ID: 'Y',
        TYPE_NAME: 'Direct'
      },
      {
        TYPE_ID: 'N',
        TYPE_NAME: 'Indirect'
      },
    ]

  }
  GetStaff(code) {
    this.params.STAFF_ID = code;
    this.http.get("WH", "SNSE193_GetStaffList", this.params.STAFF_ID)
      .subscribe(result => {
        if (result.Table.length > 0) {
          this.params.STAFF_NAME = result.Table[0].STAFF_NAME;
        }
      });
  }
  GrdSelect(evt) {
    this.params.STAFF_ID = evt.STAFF_ID;
    this.params.STAFF_NAME = evt.STAFF_NAME;
    this.dialog.Close();
  }

  ShowStaffList() {
    this.http.get("WH", "SNSE193_GetStaffList", null)
      .subscribe(result => {
        if (result.Table.length > 0) {
          this.StaffList = result.Table;
        }
        this.dialog.title = "List of Staff";
        this.dialog.OpenDialog();
      });

  }

  Search() {
    this.http.get("WH", "SNSE193_SearchStaffList", this.params.STAFF_ID)
      .subscribe(result => {
        if (result.Table.length > 0) {
          this.data = result.Table;
          this.RowCount = result.Table.length;
        } else {
          this.data = {};
          this.RowCount = 0;
        }
      });  
  }
  ExportToExcel() {
    this.global.GoToReport("PMS_RPT_WH_SNSE193",
      {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_STAFF_ID: this.params.STAFF_ID 
      });
  }
}
