import { Component, OnInit, ViewContainerRef } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from '../../../core/modal.service';

@Component({
  selector: 'snse194',
  templateUrl: './SNSE194.component.html',
  styleUrls: ['./SNSE194.component.css']
})

export class SNSE194Component implements OnInit {

  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) { }


  public FileName: any;
  public ShowPreview: any = true;
  public ShowUpload: any = true;
  public tableData: any;
  public files: any;
  public rowCount: any = 0;

  ngOnInit() {

  }

  fileChange(p: any) {
    this.ShowPreview = false;
    this.FileName = p.target.files[0].name;
    this.files = p.target.files;

  }

  LoadData() {
    let formData = new FormData();
    formData.append('file', this.files[0]);
    this.ShowUpload = true;
    this.http.postFile('WH', 'SNSE194_UploadFiles', formData)
      .subscribe(res => {
        if (res.Table !== null) {
          if (res.Table.length > 0) {
            this.rowCount = res.Table.length;
          }
        }
        this.tableData = res.Table;
      });
  }

  SaveData() {
    if (this.tableData.length > 0) {
      this.tableData[0].CREATE_FILE_NAME = this.FileName;
    }

    this.http.post('WH', 'SNSE194_UpdateUpload', this.tableData)
      .subscribe(res => {
        if (res.Table1[0].STATUS === "DONE") {
          this.modal.info('Transaction complete', this.viewref);
          this.tableData = {};
          this.files = "";
          this.FileName = "";
          this.ShowUpload = true;
          this.ShowPreview = true;
          this.rowCount = 0;
        }
      });
  }
}
